C     
C     These are up O(xm1^16).
C     gg and qg include 1/mt^6.
C     
C-{{{ function sgg2mtexp(xt)

      real*8 function sgg2mtexp(xt)
C     
C     
      implicit none
      integer i,j,k
      real*8 xt,xm1,dlxm1,dlm1os,nl,sum,bininv
      real*8 help(10,0:20),helpmt(0:20),helpx(0:20)
      include '../commons/common-errors.f'
      include '../commons/common-expand.f'
      include '../commons/common-keys.f'
      include '../commons/common-consts.f'
      include '../commons/common-vars.f'

      help=0.d0

      if (lpseudo) stop 'sgg2mtexp'
      if (nmtlim(2,1).gt.6) stop 'sgg2mtexp'
      if (nsoftmt(2,1).gt.16) stop 'sgg2mtexp'

      xm1 = 1.d0-xt
      dlxm1 = dlog(xm1)
      
      nl=nf
      dlm1os = - lth

C-{{{ 1/mt^2:

      help(1,0) = 1251/80.d0 - (5881*dlxm1)/144.d0 + (959*dlxm1**2)
     &     /40.d0- (84*dlxm1**3)/5.d0 - (539*nl)/1080.d0 + (707*dlxm1
     &     *nl)/720.d0 - (7*dlxm1**2*nl)/15.d0 - (343*z2)/20.d0 + 21
     &     *dlxm1*z2+ (7*nl*z2)/15.d0 - (819*z3)/20.d0
      help(1,0) = help(1,0) + (7367*lfh)/360.d0 - (112*dlxm1*lfh)/5.d0 +
     &     (126*dlxm1**2*lfh)/5.d0 + (161*lfh**2)/40.d0 - (42*dlxm1*lfh
     &     **2) /5.d0 - (231*lfr)/40.d0 + (231*dlxm1*lfr)/10.d0 - (231
     &     *lfh *lfr)/20.d0 - (91*lfh*nl)/180.d0 + (7*dlxm1*lfh*nl)
     &     /15.d0 - (7*lfh**2*nl)/60.d0 + (7*lfr*nl)/20.d0 - (7*dlxm1
     &     *lfr*nl)/5.d0 + (7*lfh*lfr*nl)/10.d0 - (21*lfh*z2)/2.d0
      help(1,1) = -31739/300.d0 + (18029*dlxm1)/120.d0 - (2823*dlxm1**2)
     &     /40.d0 +(126*dlxm1**3)/5.d0 + (27*lth)/40.d0 + (2963*nl)
     &     /1440.d0 - (107*dlxm1*nl)/40.d0 + (77*dlxm1**2*nl)/90.d0 +
     &     (4737*z2)/80.d0 - (63*dlxm1*z2)/2.d0- (77*nl*z2)/90.d0 +
     &     (2457*z3)/40.d0
      help(1,1) = help(1,1) + (-17699*lfh)/240.d0 + (681*dlxm1*lfh)
     &     /10.d0 -(189*dlxm1**2*lfh)/5.d0 - (231*lfh**2)/16.d0 + (63
     &     *dlxm1*lfh**2)/5.d0 +(99*lfr)/10.d0 - (693*dlxm1*lfr)/20.d0 +
     &     (693*lfh*lfr)/40.d0 + (41*lfh*nl)/30.d0 - (77*dlxm1*lfh*nl)
     &     /90.d0 + (77*lfh**2*nl)/360.d0 - (3*lfr*nl)/5.d0 + (21*dlxm1
     &     *lfr*nl)/10.d0 - (21*lfh*lfr*nl)/20.d0 + (63*lfh*z2)/4.d0
      help(1,2) = 3306653/21600.d0 - (128573*dlxm1)/720.d0 + (6423
     &     *dlxm1**2)/80.d0- (84*dlxm1**3)/5.d0 - (27*lth)/40.d0 -
     &     (46307 *nl)/17280.d0 + (1999*dlxm1*nl)/720.d0 - (28*dlxm1**2
     &     *nl) /45.d0 - (5059*z2)/80.d0 + 21*dlxm1*z2 + (28*nl*z2)
     &     /45.d0 - (819*z3)/20.d0
      help(1,2) = help(1,2) + (31511*lfh)/360.d0 - (153*dlxm1*lfh)/2.d0
     &     + (126*dlxm1**2*lfh)/5.d0 + (609*lfh**2)/40.d0 - (42*dlxm1
     &     *lfh**2)/5.d0 - (1177*lfr)/80.d0 + (231*dlxm1*lfr)/10.d0 -
     &     (231*lfh*lfr)/20.d0 - (101*lfh*nl)/72.d0 + (28*dlxm1*lfh*nl)
     &     /45.d0 - (7*lfh**2*nl)/45.d0 + (107*lfr*nl)/120.d0 - (7*dlxm1
     &     *lfr*nl)/5.d0 + (7*lfh*lfr*nl)/10.d0 - (21*lfh*z2)/2.d0
      help(1,3) = -10128949/69120.d0 + (52373*dlxm1)/360.d0 - (8099
     &     *dlxm1**2)/160.d0 + (42*dlxm1**3)/5.d0 + (399571*nl)
     &     /155520.d0 - (1051*dlxm1*nl)/540.d0 + (7*dlxm1**2*nl)/18.d0 +
     &     (301*z2) /8.d0 - (21*dlxm1*z2)/2.d0 - (7*nl*z2)/18.d0 + (819
     &     *z3)/40.d0
      help(1,3) = help(1,3) + (-100183*lfh)/1440.d0 + (1967*dlxm1*lfh)
     &     /40.d0 -(63*dlxm1**2*lfh)/5.d0 - (791*lfh**2)/80.d0 + (21
     &     *dlxm1 *lfh**2)/5.d0 +(847*lfr)/80.d0 - (231*dlxm1*lfr)/20.d0
     &     + (231 *lfh*lfr)/40.d0 + (1051*lfh*nl)/1080.d0 - (7*dlxm1*lfh
     &     *nl) /18.d0 + (7*lfh**2*nl)/72.d0 - (77*lfr*nl)/120.d0 + (7
     &     *dlxm1 *lfr*nl)/10.d0 - (7*lfh*lfr*nl)/20.d0 + (21*lfh*z2)
     &     /4.d0
      help(1,4) = 36262931/720000.d0 - (14483*dlxm1)/400.d0 + (4557
     &     *dlxm1**2)/400.d0 - (663937*nl)/1152000.d0 + (761*dlxm1*nl)
     &     /2700.d0 - (1323*z2)/200.d0
      help(1,4) = help(1,4) + (6879*lfh)/400.d0 - (1029*dlxm1*lfh)
     &     /100.d0 +(147*lfh**2)/100.d0 - (1617*lfr)/400.d0 - (761*lfh
     &     *nl)/5400.d0 + (49*lfr*nl)/200.d0
      help(1,5) = 3560687/320000.d0 - (12437*dlxm1)/1500.d0 + (4333
     &     *dlxm1**2)/800.d0 - (560119*nl)/9720000.d0 + (514*dlxm1*nl)
     &     /10125.d0 + (7*dlxm1**2*nl)/1350.d0 - (1211*z2)/400.d0 - (7
     &     *nl *z2)/1350.d0
      help(1,5) = help(1,5) + (58403*lfh)/12000.d0 - (973*dlxm1*lfh)
     &     /200.d0 +(133*lfh**2)/200.d0 - (1617*lfr)/800.d0 - (257*lfh
     &     *nl)/10125.d0 - (7*dlxm1*lfh*nl)/1350.d0 + (7*lfh**2*nl)
     &     /5400.d0 + (49*lfr*nl)/400.d0
      help(1,6) = 75211103/14112000.d0 - (5771*dlxm1)/2000.d0 + (1469
     &     *dlxm1**2)/400.d0 + (4755473*nl)/362880000.d0 - (37*dlxm1*nl)
     &     /9000.d0 + (7*dlxm1**2*nl)/1350.d0 - (403*z2)/200.d0 - (7*nl
     &     *z2)/1350.d0
      help(1,6) = help(1,6) + (13879*lfh)/6000.d0 - (329*dlxm1*lfh)
     &     /100.d0 +(11*lfh**2)/25.d0 - (561*lfr)/400.d0 + (37*lfh*nl)
     &     /18000.d0 - (7*dlxm1*lfh*nl)/1350.d0 + (7*lfh**2*nl)/5400.d0
     &     + (17*lfr*nl)/200.d0
      help(1,7) = 4008204311.d0/1128960000.d0 - (7233*dlxm1)/7000.d0 +
     &     (909*dlxm1**2)/320.d0 + (21758357*nl)/762048000.d0 - (30991
     &     *dlxm1*nl) /1134000.d0 + (dlxm1**2*nl)/225.d0 - (1239*z2)
     &     /800.d0 -(nl*z2)/225.d0
      help(1,7) = help(1,7) + (22047*lfh)/16000.d0 - (1017*dlxm1*lfh)
     &     /400.d0 +(27*lfh**2)/80.d0 - (1749*lfr)/1600.d0 + (30991*lfh
     &     *nl)/2268000.d0 -(dlxm1*lfh*nl)/225.d0 + (lfh**2*nl)/900.d0 +
     &     (53*lfr*nl)/800.d0
      help(1,8) = 2606199829.d0/952560000.d0 - (2017*dlxm1)/10080.d0 +
     &     (5627*dlxm1**2)/2400.d0 + (381261113*nl)/12192768000.d0 -
     &     (4607*dlxm1*nl)/113400.d0 + (dlxm1**2*nl)/270.d0 - (511*z2)
     &     /400.d0 - (nl*z2)/270.d0
      help(1,8) = help(1,8) + (92993*lfh)/100800.d0 - (1259*dlxm1*lfh)
     &     /600.d0+ (167*lfh**2)/600.d0 - (2167*lfr)/2400.d0 + (4607*lfh
     &     *nl)/226800.d0 -(dlxm1*lfh*nl)/270.d0 + (lfh**2*nl)/1080.d0 +
     &     (197*lfr*nl)/3600.d0
      help(1,9) = 68878689107.d0/30481920000.d0 + (181171*dlxm1)
     &     /756000.d0+(9647*dlxm1**2)/4800.d0 + (205564271*nl)
     &     /6858432000.d0 -(101267*dlxm1*nl)/2041200.d0 + (dlxm1**2*nl)
     &     /324.d0 - (2633*z2)/2400.d0 - (nl*z2)/324.d0
      help(1,9) = help(1,9) + (398711*lfh)/604800.d0 - (2159*dlxm1*lfh)
     &     /1200.d0 + (287*lfh**2)/1200.d0 - (3707*lfr)/4800.d0 +
     &     (101267*lfh*nl) /4082400.d0 - (dlxm1*lfh*nl)/324.d0 + (lfh**2
     &     *nl)/1296.d0 + (337*lfr *nl) /7200.d0
      help(1,10) = 1637467668911.d0/845238240000.d0 + (17869*dlxm1)
     &     /36000.d0 +(15539*dlxm1**2)/8800.d0 + (257745152219.d0*nl)
     &     /9484231680000.d0 -(150419*dlxm1*nl)/2673000.d0 + (7*dlxm1**2
     &     *nl)/2700.d0 - (4253*z2)/4400.d0 - (7*nl*z2)/2700.d0
      help(1,10) = help(1,10) + (35219*lfh)/72000.d0 - (3479*dlxm1*lfh)
     &     /2200.d0 + (58*lfh**2)/275.d0 - (541*lfr)/800.d0 + (150419
     &     *lfh*nl) /5346000.d0 - (7*dlxm1*lfh*nl)/2700.d0 + (7*lfh**2
     &     *nl)/10800.d0 + (541 *lfr*nl)/13200.d0
      help(1,11) = 9851466660289.d0/5795919360000.d0 + (17150929*dlxm1)
     &     /26136000.d0 + (27783*dlxm1**2)/17600.d0 + (29081695409.d0
     &     *nl) /1222576740000.d0 - (10848569*dlxm1*nl)/176418000.d0 +
     &     (49 *dlxm1**2 *nl)/22275.d0 - (22883*z2)/26400.d0 - (49*nl
     &     *z2) /22275.d0
      help(1,11) = help(1,11) + (19383239*lfh)/52272000.d0 - (6223*dlxm1
     &     *lfh)/4400.d0 + (833*lfh**2)/4400.d0 - (2891*lfr)/4800.d0 +
     &     (10848569 *lfh*nl)/352836000.d0 - (49*dlxm1*lfh*nl)/22275.d0
     &     + (49*lfh**2*nl) /89100.d0 + (2891*lfr*nl)/79200.d0
      help(1,12) = 13400706443119.d0/8842801968000.d0 + (7170973*dlxm1)
     &     /9438000.d0 + (49063*dlxm1**2)/34320.d0 + (5931664224713.d0
     &     *nl) /293853111552000.d0 - (4187551*dlxm1*nl)/63706500.d0 +
     &     (14 *dlxm1**2 *nl)/7425.d0 - (22519*z2)/28600.d0 - (14*nl*z2)
     &     /7425.d0
      help(1,12) = help(1,12) + (10727527*lfh)/37752000.d0 - (54971
     &     *dlxm1*lfh)/42900.d0 + (1477*lfh**2)/8580.d0 - (8477*lfr)
     &     /15600.d0 + (4187551*lfh*nl)/127413000.d0 - (14*dlxm1*lfh*nl)
     &     /7425.d0 + (7*lfh**2*nl)/14850.d0 + (8477*lfr*nl)/257400.d0
      help(1,13) = 1.3676266204530714d0 + 0.8283424880286768d0*dlxm1 +
     &     1.307701048951049d0*dlxm1**2 + 0.01654791574549853d0*nl -
     &     0.06925917775568126d0*dlxm1*nl + 0.0016317016317016317d0
     &     *dlxm1**2*nl - 0.7223601398601398d0*z2 -
     &     0.0016317016317016317d0*nl*z2
      help(1,13) = help(1,13) + 0.21833830893271453d0*lfh -
     &     1.1726223776223776d0*dlxm1*lfh + 0.1580769230769231d0*lfh**2
     &     -0.4952884615384615d0*lfr + 0.03462958887784063d0*lfh*nl
     &     -0.0016317016317016317d0*dlxm1*lfh*nl
     &     +0.0004079254079254079d0*lfh**2*nl + 0.030017482517482517d0
     &     *lfr*nl
      help(1,14) = 1.246232743557262d0 + 0.8739277399950477d0*dlxm1 +
     &     1.2058916083916085d0*dlxm1**2 + 0.012959601592764011d0*nl -
     &     0.07224864720591216d0*dlxm1*nl + 0.0014245014245014246d0
     &     *dlxm1**2*nl - 0.6679370629370629d0*z2 -
     &     0.0014245014245014246d0*nl*z2
      help(1,14) = help(1,14) + 0.16697706406841023d0*lfh -
     &     1.0817482517482517d0*dlxm1*lfh + 0.1462937062937063d0*lfh**2
     &     -0.4551923076923077d0*lfr + 0.03612432360295608d0*lfh*nl
     &     -0.0014245014245014246d0*dlxm1*lfh*nl
     &     +0.00035612535612535614d0*lfh**2*nl + 0.027587412587412586d0
     &     *lfr*nl
      help(1,15) = 1.1447000678562764d0 + 0.9038785770853078d0*dlxm1 +
     &     1.1193990384615384d0*dlxm1**2 + 0.009463597919105038d0*nl -
     &     0.07481853956426605d0*dlxm1*nl + 0.0012535612535612536d0
     &     *dlxm1**2*nl - 0.6215865384615384d0*z2 -
     &     0.0012535612535612536d0*nl*z2
      help(1,15) = help(1,15) + 0.12606121616097576d0*lfh -
     &     1.0045192307692308d0*dlxm1*lfh + 0.13625d0*lfh**2 -
     &     0.42122596153846154d0*lfr + 0.03740926978213303d0*lfh*nl -
     &     0.0012535612535612536d0*dlxm1*lfh*nl +
     &     0.0003133903133903134d0*lfh**2*nl + 0.025528846153846155d0
     &     *lfr*nl
      help(1,16) = 1.0585055028393817d0 + 0.9228722494825436d0*dlxm1 +
     &     1.0449010180995475d0*dlxm1**2 + 0.00608028506014747d0*nl -
     &     0.0770532588326706d0*dlxm1*nl + 0.0011111111111111111d0*dlxm1
     &     **2*nl - 0.5815554298642533d0*z2 - 0.0011111111111111111d0*nl
     &     *z2
      help(1,16) = help(1,16) + 0.09293022765633059d0*lfh -
     &     0.937975113122172d0*dlxm1*lfh + 0.12756787330316743d0*lfh**2
     &     -0.3920616515837104d0*lfr + 0.0385266294163353d0*lfh*nl
     &     -0.0011111111111111111d0*dlxm1*lfh*nl +
     &     0.0002777777777777778d0*lfh**2*nl + 0.02376131221719457d0*lfr
     &     *nl

C-}}}
C-{{{ 1/mt^4:

      help(2,0) = 2682619/1209600.d0 - (2428319*dlxm1)/403200.d0 +
     &     (211391*dlxm1**2)/67200.d0 - (1543*dlxm1**3)/700.d0 - (16973
     &     *nl)/259200.d0 + (155843*dlxm1*nl)/1209600.d0 - (1543*dlxm1
     &     **2*nl)/25200.d0 - (10801*z2)/4800.d0 + (1543*dlxm1*z2)
     &     /560.d0 + (1543*nl*z2)/25200.d0 - (60177*z3)/11200.d0
      help(2,0) = help(2,0) + (86891*lfh)/28800.d0 - (1543*dlxm1*lfh)
     &     /525.d0 + (4629*dlxm1**2*lfh)/1400.d0 + (35489*lfh**2)
     &     /67200.d0 - (1543*dlxm1*lfh**2)/1400.d0 - (16973*lfr)
     &     /22400.d0 + (16973*dlxm1*lfr)/5600.d0 - (16973*lfh*lfr)
     &     /11200.d0 - (20059*lfh*nl)/302400.d0 + (1543*dlxm1*lfh*nl)
     &     /25200.d0 - (1543*lfh**2*nl)/100800.d0 + (1543*lfr*nl)
     &     /33600.d0 - (1543*dlxm1*lfr*nl)/8400.d0 + (1543*lfh*lfr*nl)
     &     /16800.d0 - (1543*lfh*z2)/1120.d0
      help(2,1) = -591611563/42336000.d0 + (1380067*dlxm1)/67200.d0 -
     &     (411541*dlxm1**2)/44800.d0 + (4629*dlxm1**3)/1400.d0 + (411
     &     *lth)/11200.d0 + (624569*nl)/2419200.d0 - (23341*dlxm1*nl)
     &     /67200.d0 + (16973*dlxm1**2*nl)/151200.d0 + (43553*z2)
     &     /5600.d0 - (4629*dlxm1*z2)/1120.d0 - (16973*nl*z2)/151200.d0
     &     + (180531*z3)/22400.d0
      help(2,1) = help(2,1) + (-677269*lfh)/67200.d0 + (4967*dlxm1*lfh)
     &     /560.d0 - (13887*dlxm1**2*lfh)/2800.d0 - (16973*lfh**2)
     &     /8960.d0 + (4629*dlxm1*lfh**2)/2800.d0 + (54153*lfr)/44800.d0
     &     - (50919*dlxm1*lfr)/11200.d0 + (50919*lfh*lfr)/22400.d0 +
     &     (35783*lfh*nl)/201600.d0 - (16973*dlxm1*lfh*nl)/151200.d0 +
     &     (16973*lfh**2*nl)/604800.d0 - (1641*lfr*nl)/22400.d0 + (1543
     &     *dlxm1*lfr*nl)/5600.d0 - (1543*lfh*lfr*nl)/11200.d0 + (4629
     &     *lfh*z2)/2240.d0
      help(2,2) = 1755825931/84672000.d0 - (9738409*dlxm1)/403200.d0 +
     &     (118373*dlxm1**2)/11200.d0 - (1543*dlxm1**3)/700.d0 - (1311
     &     *lth)/11200.d0 - (10238033*nl)/29030400.d0 + (20863*dlxm1*nl)
     &     /57600.d0 - (1543*dlxm1**2*nl)/18900.d0 - (111463*z2)
     &     /13440.d0 + (1543*dlxm1*z2)/560.d0 + (1543*nl*z2)/18900.d0 -
     &     (60177*z3)/11200.d0
      help(2,2) = help(2,2) + (957769*lfh)/80640.d0 - (28191*dlxm1*lfh)
     &     /2800.d0 + (4629*dlxm1**2*lfh)/1400.d0 + (44747*lfh**2)
     &     /22400.d0 - (1543*dlxm1*lfh**2)/1400.d0 - (33143*lfr)
     &     /16800.d0 + (16973*dlxm1*lfr)/5600.d0 - (16973*lfh*lfr)
     &     /11200.d0 - (1153*lfh*nl)/6300.d0 + (1543*dlxm1*lfh*nl)
     &     /18900.d0 - (1543*lfh**2*nl)/75600.d0 + (3013*lfr*nl)
     &     /25200.d0 - (1543*dlxm1*lfr*nl)/8400.d0 + (1543*lfh*lfr*nl)
     &     /16800.d0 - (1543*lfh*z2)/1120.d0
      help(2,3) = -25696781597.d0/1354752000.d0 + (770519*dlxm1)
     &     /40320.d0 -(1754831*dlxm1**2)/268800.d0 + (1543*dlxm1**3)
     &     /1400.d0 - (963*lth)/11200.d0 + (15468809*nl)/52254720.d0 -
     &     (5257*dlxm1*nl)/21600.d0 + (1543*dlxm1**2*nl)/30240.d0 +
     &     (332429*z2)/67200.d0 - (1543*dlxm1*z2)/1120.d0 - (1543*nl*z2)
     &     /30240.d0 +(60177*z3)/22400.d0
      help(2,3) = help(2,3) + (-7335731*lfh)/806400.d0 + (426851*dlxm1
     &     *lfh)/67200.d0 - (4629*dlxm1**2*lfh)/2800.d0 - (174359*lfh
     &     **2)/134400.d0 + (1543*dlxm1*lfh**2)/2800.d0 + (16819*lfr)
     &     /13440.d0 - (16973*dlxm1*lfr)/11200.d0 + (16973*lfh*lfr)
     &     /22400.d0 + (5257*lfh*nl)/43200.d0 - (1543*dlxm1*lfh*nl)
     &     /30240.d0 + (1543*lfh**2*nl)/120960.d0 - (1529*lfr*nl)
     &     /20160.d0 + (1543*dlxm1*lfr*nl)/16800.d0 - (1543*lfh*lfr*nl)
     &     /33600.d0 + (1543*lfh*z2)/2240.d0
      help(2,4) = 8835192869.d0/1209600000.d0 - (1704181*dlxm1)
     &     /336000.d0 +(52183*dlxm1**2)/32000.d0 - (21*lth)/200.d0 -
     &     (2015171017*nl)/17418240000.d0 + (78653*dlxm1*nl)/1512000.d0
     &     - (6861*z2)/8000.d0
      help(2,4) = help(2,4) + (558367*lfh)/224000.d0 - (11761*dlxm1*lfh)
     &     /8000.d0 + (1543*lfh**2)/8000.d0 - (22253*lfr)/32000.d0 -
     &     (78653*lfh*nl)/3024000.d0 + (2023*lfr*nl)/48000.d0
      help(2,5) = 23853086393.d0/11289600000.d0 - (511469*dlxm1)
     &     /360000.d0+ (1168417*dlxm1**2)/1344000.d0 - (1389*lth)
     &     /11200.d0 -(1842309977*nl)/32659200000.d0 + (1969759*dlxm1
     &     *nl)/68040000.d0 + (1543*dlxm1**2*nl)/2268000.d0 - (259919
     &     *z2)/672000.d0 - (1543*nl*z2)/2268000.d0
      help(2,5) = help(2,5) + (18343517*lfh)/20160000.d0 - (37351*dlxm1
     &     *lfh)/48000.d0 + (29317*lfh**2)/336000.d0 - (204941*lfr)
     &     /448000.d0 - (1969759*lfh*nl)/136080000.d0 - (1543*dlxm1*lfh
     &     *nl)/2268000.d0 + (1543*lfh**2*nl)/9072000.d0 + (18631*lfr
     &     *nl)/672000.d0
      help(2,6) = 3537902521.d0/2593080000.d0 - (8583559*dlxm1)
     &     /11760000.d0+ (3120317*dlxm1**2)/4704000.d0 - (801*lth)
     &     /5600.d0 -(684518132203.d0*nl)/12802406400000.d0 + (27584971
     &     *dlxm1*nl)/952560000.d0 + (1543*dlxm1**2*nl)/2268000.d0 -
     &     (37309*z2)/147000.d0 - (1543*nl*z2)/2268000.d0
      help(2,6) = help(2,6) + (43255507*lfh)/70560000.d0 - (99341*dlxm1
     &     *lfh)/168000.d0 + (16973*lfh**2)/294000.d0 - (632731*lfr)
     &     /1568000.d0 - (27584971*lfh*nl)/1905120000.d0 - (1543*dlxm1
     &     *lfh*nl)/2268000.d0 + (1543*lfh**2*nl)/9072000.d0 + (57521
     &     *lfr*nl)/2352000.d0
      help(2,7) = 15290540810593.d0/13276569600000.d0 - (868663*dlxm1)
     &     /1715000.d0 + (723729*dlxm1**2)/1254400.d0 - (363*lth)
     &     /2240.d0 - (506234663357.d0*nl)/8961684480000.d0 + (49141123
     &     *dlxm1*nl)/1481760000.d0 + (1543*dlxm1**2*nl)/2646000.d0 -
     &     (86237*z2)/448000.d0 - (1543*nl*z2)/2646000.d0
      help(2,7) = help(2,7) + (232520669*lfh)/439040000.d0 - (804477
     &     *dlxm1*lfh)/1568000.d0 + (13887*lfh**2)/313600.d0 - (2447269
     &     *lfr)/6272000.d0 - (49141123*lfh*nl)/2963520000.d0 - (1543
     &     *dlxm1*lfh*nl)/2646000.d0 + (1543*lfh**2*nl)/10584000.d0 +
     &     (222479*lfr*nl)/9408000.d0
      help(2,8) = 11945174358937.d0/11202105600000.d0 - (15428951*dlxm1)
     &     /37044000.d0 + (15089561*dlxm1**2)/28224000.d0 - (507*lth)
     &     /2800.d0 - (8635605063233.d0*nl)/143386951680000.d0 +
     &     (103239179 *dlxm1*nl)/2667168000.d0 + (1543*dlxm1**2*nl)
     &     /3175200.d0 - (105349*z2)/672000.d0 - (1543*nl*z2)/3175200.d0
      help(2,8) = help(2,8) + (604173323*lfh)/1185408000.d0 - (3348797
     &     *dlxm1*lfh)/7056000.d0 + (257681*lfh**2)/7056000.d0 -
     &     (11077561*lfr)/28224000.d0 - (103239179*lfh*nl)/5334336000.d0
     &     - (1543*dlxm1*lfh*nl)/3175200.d0 + (1543*lfh**2*nl)
     &     /12700800.d0 + (1007051*lfr*nl)/42336000.d0
      help(2,9) = 367030802805281.d0/358467379200000.d0 - (3354069407.d0
     &     *dlxm1)/8890560000.d0 + (28984721*dlxm1**2)/56448000.d0 -
     &     (2241*lth)/11200.d0 - (5139459659387.d0*nl)/80655160320000.d0
     &     + (1076407189*dlxm1*nl)/24004512000.d0 + (1543*dlxm1**2*nl)
     &     /3810240.d0 - (3752759*z2)/28224000.d0 - (1543*nl*z2)
     &     /3810240.d0
      help(2,9) = help(2,9) + (3664693673.d0*lfh)/7112448000.d0 -
     &     (6423377*dlxm1*lfh)/14112000.d0 + (63263*lfh**2)/2016000.d0
     &     -(22726121*lfr)/56448000.d0 - (1076407189*lfh*nl)
     &     /48009024000.d0 - (1543*dlxm1*lfh*nl)/3810240.d0 + (1543*lfh
     &     **2*nl)/15240960.d0 + (2066011*lfr*nl)/84672000.d0
      help(2,10) = 39741268389155297.d0/39760006809600000.d0 -
     &     (38205437.d0*dlxm1)/105840000.d0 + (52181777*dlxm1**2)
     &     /103488000.d0 -(1227*lth)/5600.d0 - (7447264905731603.d0*nl)
     &     /111534564556800000.d0 + (65817889*dlxm1*nl)/1283040000.d0
     &     +(1543*dlxm1**2*nl)/4536000.d0 - (5987189*z2)/51744000.d0
     &     -(1543*nl*z2)/4536000.d0
      help(2,10) = help(2,10) + (451521557.d0*lfh)/846720000.d0 -
     &     (1649951*dlxm1*lfh)/3696000.d0 + (44747*lfh**2)/1617000.d0 -
     &     (3925543*lfr)/9408000.d0 - (65817889*lfh*nl)/2566080000.d0 -
     &     (1543*dlxm1*lfh*nl)/4536000.d0 + (1543*lfh**2*nl)/18144000.d0
     &     +(3925543*lfr*nl)/155232000.d0
      help(2,11) = 9581188578797761.d0/9737144524800000.d0 -
     &     (109500595973.d0*dlxm1)/307359360000.d0 + (707427*dlxm1**2)
     &     /1408000.d0 - (381*lth)/1600.d0 - (71216845033337.d0*nl)
     &     /1026964461600000.d0 +(17177122819.d0*dlxm1*nl)
     &     /296382240000.d0 + (1543*dlxm1**2*nl)/5346000.d0 - (649301
     &     *z2)/6336000.d0 - (1543*nl*z2)/5346000.d0
      help(2,11) = help(2,11) + (343137665177.d0*lfh)/614718720000.d0 -
     &     (469201*dlxm1*lfh)/1056000.d0 + (26231*lfh**2)/1056000.d0 -
     &     (500897*lfr)/1152000.d0 - (17177122819.d0*lfh*nl)
     &     /592764480000.d0 - (1543*dlxm1*lfh*nl)/5346000.d0 + (1543*lfh
     &     **2*nl)/21384000.d0 + (500897*lfr*nl)/19008000.d0
      help(2,12) = 1214339485731874729.d0/1247896213724160000.d0 -
     &     (19855896913.d0*dlxm1)/55495440000.d0 + (29154637*dlxm1**2)
     &     /57657600.d0 - (9*lth)/35.d0 - (9147293390153059.d0*nl)
     &     /127989355253760000.d0 + (24255256111.d0*dlxm1*nl)
     &     /374594220000.d0 + (1543*dlxm1**2*nl)/6237000.d0 - (552107
     &     *z2)/6006000.d0 - (1543*nl*z2)/6237000.d0
      help(2,12) = help(2,12) + (5322209449.d0*lfh)/9060480000.d0 -
     &     (4599197*dlxm1*lfh)/10296000.d0 + (325573*lfh**2)/14414400.d0
     &     - (11907173*lfr)/26208000.d0 - (24255256111.d0*lfh*nl)
     &     /749188440000.d0 - (1543*dlxm1*lfh*nl)/6237000.d0 + (1543*lfh
     &     **2*nl)/24948000.d0 + (11907173*lfr*nl)/432432000.d0
      help(2,13) = 0.9647748590934198d0 - 0.36279607943185416d0*dlxm1 +
     &     0.5124283774261453d0*dlxm1**2 - 0.27616071428571426d0*lth -
     &     0.07316905251817732d0*nl + 0.07164487024350077d0*dlxm1*nl +
     &     0.0002140914640914641d0*dlxm1**2*nl - 0.08326119862280576d0
     &     *z2 -0.0002140914640914641d0*nl*z2
      help(2,13) = help(2,13) + 0.6194315547712375d0*lfh -
     &     0.45224968781218783d0*dlxm1*lfh + 0.02074087519623234d0*lfh
     &     **2 -0.4752757309654631d0*lfr - 0.03582243512175039d0*lfh*nl
     &     -0.0002140914640914641d0*dlxm1*lfh*nl +
     &     0.00005352286602286602d0*lfh**2*nl + 0.028804589755482612d0
     &     *lfr*nl
      help(2,14) = 0.9577622760886964d0 - 0.36971696918598657d0*dlxm1 +
     &     0.5218380741282527d0*dlxm1**2 - 0.2951785714285714d0*lth -
     &     0.0744790459452591d0*nl + 0.07861401371953584d0*dlxm1*nl +
     &     0.00018690524642905594d0*dlxm1**2*nl - 0.07598655511155511d0
     &     *z2 -0.00018690524642905594d0*nl*z2
      help(2,14) = help(2,14) + 0.653415354243326d0*lfh -
     &     0.46014775105846534d0*dlxm1*lfh + 0.019194828980543265d0*lfh
     &     **2 -0.49726927982731556d0*lfr - 0.03930700685976792d0*lfh*nl
     &     -0.00018690524642905594d0*dlxm1*lfh*nl +
     &     0.000046726311607263985d0*lfh**2*nl + 0.030137532110746396d0
     &     *lfr*nl
      help(2,15) = 0.9513236376479577d0 - 0.377631501017089d0*dlxm1 +
     &     0.5332574588729723d0*dlxm1**2 - 0.3141964285714286d0*lth -
     &     0.07542936239936693d0*nl + 0.08564156492506923d0*dlxm1*nl +
     &     0.00016447661685756924d0*dlxm1**2*nl - 0.06977109088827839d0
     &     *z2 -0.00016447661685756924d0*nl*z2
      help(2,15) = help(2,15) + 0.6888214529087343d0*lfh -
     &     0.46983615417320773d0*dlxm1*lfh + 0.01787701955782313d0*lfh
     &     **2 -0.5200671053277081d0*lfr - 0.042820782462534616d0*lfh*nl
     &     -0.00016447661685756924d0*dlxm1*lfh*nl +
     &     0.00004111915421439231d0*lfh**2*nl + 0.031519218504709574d0
     &     *lfr*nl
      help(2,16) = 0.944977320040979d0 - 0.38596474966721067d0*dlxm1 +
     &     0.5462506182761566d0*dlxm1**2 - 0.33321428571428574d0*lth -
     &     0.07604713300941836d0*nl + 0.09271566344665418d0*dlxm1*nl +
     &     0.00014578609221466366d0*dlxm1**2*nl - 0.06438478131637271d0
     &     *z2 -0.00014578609221466366d0*nl*z2
      help(2,16) = help(2,16) + 0.7252913099965503d0*lfh -
     &     0.4809264965601625d0*dlxm1*lfh + 0.016737859566903684d0*lfh
     &     **2 -0.543494993911026d0*lfr - 0.04635783172332709d0*lfh*nl
     &     -0.00014578609221466366d0*dlxm1*lfh*nl +
     &     0.000036446523053665914d0*lfh**2*nl + 0.03293909054006218d0
     &     *lfr*nl

C-}}}
C-{{{ 1/mt^6:

      help(3,0) = 0.34544027147896195d0 - 0.9645504377676997d0*dlxm1 +
     &     0.46074404761904764d0*dlxm1**2 - 0.32285714285714284d0*dlxm1
     &     **3 - 0.009591049382716049d0*nl + 0.01887070105820106d0*dlxm1
     &     *nl - 0.008968253968253969d0*dlxm1**2*nl -
     &     0.32958333333333334d0*z2 + 0.4035714285714286d0*dlxm1*z2 +
     &     0.008968253968253969d0*nl*z2 - 0.7869642857142857d0*z3
      help(3,0) = help(3,0) + 0.48311599269337363d0*lfh -
     &     0.43047619047619046d0*dlxm1*lfh + 0.48428571428571426d0*dlxm1
     &     **2*lfh + 0.07735119047619048d0*lfh**2 -
     &     0.16142857142857142d0*dlxm1*lfh**2 - 0.11098214285714286d0
     &     *lfr + 0.44392857142857145d0*dlxm1*lfr -
     &     0.22196428571428573d0*lfh*lfr - 0.009715608465608466d0*lfh*nl
     &     + 0.008968253968253969d0*dlxm1*lfh*nl -
     &     0.0022420634920634923d0*lfh**2*nl + 0.006726190476190476d0
     &     *lfr*nl - 0.026904761904761904d0*dlxm1*lfr*nl +
     &     0.013452380952380952d0*lfh*lfr*nl - 0.2017857142857143d0*lfh
     &     *z2
      help(3,1) = -2.010518083506551d0 + 3.0913702995086925d0*dlxm1 -
     &     1.3283928571428572d0*dlxm1**2 + 0.48428571428571426d0*dlxm1
     &     **3 - 0.006278273809523809d0*lth + 0.034966104497354496d0*nl
     &     - 0.0500297619047619d0*dlxm1*nl + 0.01644179894179894d0*dlxm1
     &     **2*nl + 1.1410267857142857d0*z2 - 0.6053571428571428d0*dlxm1
     &     *z2 - 0.01644179894179894d0*nl*z2 + 1.1804464285714287d0*z3
      help(3,1) = help(3,1)  -1.5158347033257749d0*lfh +
     &     1.2839285714285715d0*dlxm1*lfh - 0.7264285714285714d0*dlxm1
     &     **2*lfh - 0.27745535714285713d0*lfh**2 +
     &     0.24214285714285713d0*dlxm1*lfh**2 + 0.1561607142857143d0*lfr
     &     - 0.6658928571428572d0*dlxm1*lfr + 0.3329464285714286d0*lfh
     &     *lfr + 0.025575396825396824d0*lfh*nl - 0.01644179894179894d0
     &     *dlxm1*lfh*nl + 0.004110449735449735d0*lfh**2*nl -
     &     0.009464285714285715d0*lfr*nl + 0.040357142857142855d0*dlxm1
     &     *lfr*nl - 0.020178571428571428d0*lfh*lfr*nl +
     &     0.3026785714285714d0*lfh*z2
      help(3,2) = 3.152672641355925d0 - 3.639114921894684d0*dlxm1 +
     &     1.5579352678571428d0*dlxm1**2 - 0.32285714285714284d0*dlxm1
     &     **3 - 0.02559672619047619d0*lth - 0.054276275903880074d0*nl +
     &     0.05331018518518518d0*dlxm1*nl - 0.011957671957671957d0*dlxm1
     &     **2*nl - 1.2136123511904762d0*z2 + 0.4035714285714286d0*dlxm1
     &     *z2 + 0.011957671957671957d0*nl*z2 - 0.7869642857142857d0*z3
      help(3,2) = help(3,2) + 1.7980849907092467d0*lfh -
     &     1.4834821428571427d0*dlxm1*lfh + 0.48428571428571426d0*dlxm1
     &     **2*lfh + 0.2925892857142857d0*lfh**2 - 0.16142857142857142d0
     &     *dlxm1*lfh**2 - 0.30106770833333335d0*lfr +
     &     0.44392857142857145d0*dlxm1*lfr - 0.22196428571428573d0*lfh
     &     *lfr - 0.026935350529100528d0*lfh*nl + 0.011957671957671957d0
     &     *dlxm1*lfh*nl - 0.0029894179894179892d0*lfh**2*nl +
     &     0.018246527777777778d0*lfr*nl - 0.026904761904761904d0*dlxm1
     &     *lfr*nl + 0.013452380952380952d0*lfh*lfr*nl -
     &     0.2017857142857143d0*lfh*z2
      help(3,3) = -2.526337586182235d0 + 2.6916120244394053d0*dlxm1 -
     &     0.9083891369047619d0*dlxm1**2 + 0.16142857142857142d0*dlxm1
     &     **3 - 0.05091170634920635d0*lth + 0.032786129176464826d0*nl -
     &     0.032992724867724865d0*dlxm1*nl + 0.007473544973544973d0
     &     *dlxm1**2*nl + 0.7300483630952381d0*z2 - 0.2017857142857143d0
     &     *dlxm1*z2 - 0.007473544973544973d0*nl*z2 +
     &     0.39348214285714284d0*z3
      help(3,3) = help(3,3)  -1.263547083648274d0*lfh +
     &     0.887827380952381d0*dlxm1*lfh - 0.24214285714285713d0*dlxm1
     &     **2*lfh - 0.19001488095238095d0*lfh**2 +
     &     0.08071428571428571d0*dlxm1*lfh**2 + 0.1248139880952381d0*lfr
     &     - 0.22196428571428573d0*dlxm1*lfr + 0.11098214285714286d0*lfh
     &     *lfr + 0.016496362433862433d0*lfh*nl - 0.007473544973544973d0
     &     *dlxm1*lfh*nl + 0.0018683862433862433d0*lfh**2*nl -
     &     0.007564484126984127d0*lfr*nl + 0.013452380952380952d0*dlxm1
     &     *lfr*nl - 0.006726190476190476d0*lfh*lfr*nl +
     &     0.10089285714285715d0*lfh*z2
      help(3,4) = 1.579011067235922d0 - 1.0041835317460317d0*dlxm1 +
     &     0.3242890625d0*dlxm1**2 - 0.08603075396825396d0*lth -
     &     0.031182294766865078d0*nl + 0.011446593915343915d0*dlxm1*nl -
     &     0.11576153273809524d0*z2
      help(3,4) = help(3,4) + 0.5322952628968254d0*lfh -
     &     0.2913363095238095d0*dlxm1*lfh + 0.02825d0*lfh**2 -
     &     0.20636867559523808d0*lfr - 0.0057232969576719575d0*lfh*nl +
     &     0.01250719246031746d0*lfr*nl
      help(3,5) = help(3,5) + 0.4050018353174603d0*lfh -
     &     0.2349642857142857d0*dlxm1*lfh + 0.012779761904761905d0*lfh
     &     **2 - 0.2333653273809524d0*lfr - 0.004825878159905938d0*lfh
     &     *nl - 0.00009964726631393299d0*dlxm1*lfh*nl +
     &     0.000024911816578483247d0*lfh**2*nl + 0.014143353174603175d0
     &     *lfr*nl
      help(3,6) = 1.285901075565182d0 - 0.6971886515022676d0*dlxm1 +
     &     0.2966718218537415d0*dlxm1**2 - 0.1901938492063492d0*lth -
     &     0.034757344065097014d0*nl + 0.011268481250524902d0*dlxm1*nl +
     &     0.00009964726631393299d0*dlxm1**2*nl - 0.014286511479591837d0
     &     *z2 - 0.00009964726631393299d0*nl*z2
      help(3,6) = help(3,6) + 0.49471767644557824d0*lfh -
     &     0.26408035714285716d0*dlxm1*lfh + 0.00845578231292517d0*lfh
     &     **2 - 0.30312728528911564d0*lfr - 0.005634240625262451d0*lfh
     &     *nl - 0.00009964726631393299d0*dlxm1*lfh*nl +
     &     0.000024911816578483247d0*lfh**2*nl + 0.018371350623582767d0
     &     *lfr*nl
      help(3,7) = 1.623844443788502d0 - 0.8763752146096534d0*dlxm1 +
     &     0.3604630102040816d0*dlxm1**2 - 0.25923789682539683d0*lth -
     &     0.04323097349595598d0*nl + 0.013535929795198503d0*dlxm1*nl +
     &     0.0000854119425547997d0*dlxm1**2*nl + 0.0033668154761904764d0
     &     *z2 - 0.0000854119425547997d0*nl*z2
      help(3,7) = help(3,7) + 0.6438449521177518d0*lfh -
     &     0.32059906462585036d0*dlxm1*lfh + 0.006485969387755102d0*lfh
     &     **2 - 0.39464721513605444d0*lfr - 0.0067679648975992514d0*lfh
     &     *nl - 0.0000854119425547997d0*dlxm1*lfh*nl +
     &     0.000021352985638699925d0*lfh**2*nl + 0.023918013038548753d0
     &     *lfr*nl
      help(3,8) = 2.0234066701979505d0 - 1.103273078973653d0*dlxm1 +
     &     0.4436456384637188d0*dlxm1**2 - 0.3395902777777778d0*lth -
     &     0.053028247677201754d0*nl + 0.01603339009766164d0*dlxm1*nl +
     &     0.00007117661879566641d0*dlxm1**2*nl + 0.018710193452380952d0
     &     *z2 - 0.00007117661879566641d0*nl*z2
      help(3,8) = help(3,8) + 0.8302817350650578d0*lfh -
     &     0.3944471371882086d0*dlxm1*lfh + 0.005348922902494331d0*lfh
     &     **2 - 0.5042697526927438d0*lfr - 0.00801669504883082d0*lfh*nl
     &     - 0.00007117661879566641d0*dlxm1*lfh*nl +
     &     0.000017794154698916603d0*lfh**2*nl + 0.03056180319349962d0
     &     *lfr*nl
      help(3,9) = 2.4673751366281143d0 - 1.3640494073489184d0*dlxm1 +
     &     0.5428646187641724d0*dlxm1**2 - 0.43125099206349204d0*lth -
     &     0.06403940096455567d0*nl + 0.018649677277338527d0*dlxm1*nl +
     &     0.00005931384899638868d0*dlxm1**2*nl + 0.03374546485260771d0
     &     *z2 - 0.00005931384899638868d0*nl*z2
      help(3,9) = help(3,9) + 1.0484137177523125d0*lfh -
     &     0.48258177437641725d0*dlxm1*lfh + 0.004596230158730159d0*lfh
     &     **2 - 0.6308498441043084d0*lfr - 0.009324838638669264d0*lfh
     &     *nl - 0.00005931384899638868d0*dlxm1*lfh*nl +
     &     0.00001482846224909717d0*lfh**2*nl + 0.038233323885109596d0
     &     *lfr*nl
      help(3,10) = 2.9479474145262476d0 - 1.6531758651029855d0*dlxm1 +
     &     0.6567659776978974d0*dlxm1**2 - 0.5342200396825397d0*lth -
     &     0.07625579776059524d0*nl + 0.021344257500044535d0*dlxm1*nl +
     &     0.00004982363315696649d0*dlxm1**2*nl + 0.04925880778447743d0
     &     *z2 - 0.00004982363315696649d0*nl*z2
      help(3,10) = help(3,10) + 1.296300286989796d0*lfh -
     &     0.5837800324675325d0*dlxm1*lfh + 0.004053184910327768d0*lfh
     &     **2 - 0.7739070471938776d0*lfr - 0.010672128750022268d0*lfh
     &     *nl - 0.00004982363315696649d0*dlxm1*lfh*nl +
     &     0.000012455908289241623d0*lfh**2*nl + 0.04690345740568955d0
     &     *lfr*nl
      help(3,11) = 3.460060202093928d0 - 1.9677171475174857d0*dlxm1 +
     &     0.7846960227272727d0*dlxm1**2 - 0.6484974206349207d0*lth -
     &     0.08968925604578962d0*nl + 0.024098695947503468d0*dlxm1*nl +
     &     0.000042274597830153385d0*dlxm1**2*nl + 0.06562001713564214d0
     &     *z2 - 0.000042274597830153385d0*nl*z2
      help(3,11) = help(3,11) + 1.5731220205137075d0*lfh -
     &     0.6974537337662338d0*dlxm1*lfh + 0.003638257575757576d0*lfh
     &     **2 - 0.9332011408730159d0*lfr - 0.012049347973751734d0*lfh
     &     *nl - 0.000042274597830153385d0*dlxm1*lfh*nl +
     &     0.000010568649457538346d0*lfh**2*nl + 0.0565576449013949d0
     &     *lfr*nl
      help(3,12) = 3.9997576514603157d0 - 2.3057602830303114d0*dlxm1 +
     &     0.9262978939463314d0*dlxm1**2 - 0.774083134920635d0*lth -
     &     0.10435491572485948d0*nl + 0.026903182554111487d0*dlxm1*nl +
     &     0.000036235369568702905d0*dlxm1**2*nl + 0.08302653336247086d0
     &     *z2 - 0.000036235369568702905d0*nl*z2
      help(3,12) = help(3,12) + 1.8784791791384121d0*lfh -
     &     0.8232828074703075d0*dlxm1*lfh + 0.003308219558219558d0*lfh
     &     **2 - 1.1085972317612942d0*lfr - 0.013451591277055744d0*lfh
     &     *nl - 0.000036235369568702905d0*dlxm1*lfh*nl +
     &     9.058842392175726d-6*lfh**2*nl + 0.06718771101583601d0*lfr*nl
      help(3,13) = 4.563673352669224d0 - 2.6658759082185672d0*dlxm1 +
     &     1.0813586681175966d0*dlxm1**2 - 0.9109771825396825d0*lth -
     &     0.12026713915590316d0*nl + 0.029751879428307166d0*dlxm1*nl +
     &     0.00003135753135753136d0*dlxm1**2*nl + 0.10159409935302792d0
     &     *z2 - 0.00003135753135753136d0*nl*z2
      help(3,13) = help(3,13) + 2.212154132802567d0*lfh -
     &     0.9610767565767566d0*dlxm1*lfh + 0.0030378728414442702d0*lfh
     &     **2 - 1.3000130903322868d0*lfr - 0.014875939714153583d0*lfh
     &     *nl - 0.00003135753135753136d0*dlxm1*lfh*nl +
     &     7.83938283938284d-6*lfh**2*nl + 0.07878867214135071d0*lfr*nl
      help(3,14) = 5.1488255188573895d0 - 3.046900466352213d0*dlxm1 +
     &     1.2497425279333763d0*dlxm1**2 - 1.0591795634920635d0*lth -
     &     0.13743862415901514d0*nl + 0.03264102319010126d0*dlxm1*nl +
     &     0.00002737562261371785d0*dlxm1**2*nl + 0.12139556537212787d0
     &     *z2 - 0.00002737562261371785d0*nl*z2
      help(3,14) = help(3,14) + 2.5740178502198714d0*lfh -
     &     1.1107142946339374d0*dlxm1*lfh + 0.002811426668569526d0*lfh
     &     **2 - 1.5073954367804814d0*lfr - 0.01632051159505063d0*lfh*nl
     &     - 0.00002737562261371785d0*dlxm1*lfh*nl + 6.8439056534294625d
     &     -6*lfh**2*nl + 0.09135729919881705d0*lfr*nl
      help(3,15) = 5.752517986523705d0 - 3.4478356243641346d0*dlxm1 +
     &     1.4313582425758764d0*dlxm1**2 - 1.2186902777777777d0*lth -
     &     0.15588037821211762d0*nl + 0.0355680425211717d0*dlxm1*nl +
     &     0.00002409054790007171d0*dlxm1**2*nl + 0.1424793956043956d0
     &     *z2 - 0.00002409054790007171d0*nl*z2
      help(3,15) = help(3,15) + 2.963988559939542d0*lfh -
     &     1.2721140600470957d0*dlxm1*lfh + 0.002618409863945578d0*lfh
     &     **2 - 1.7307080839547357d0*lfr - 0.01778402126058585d0*lfh*nl
     &     - 0.00002409054790007171d0*dlxm1*lfh*nl + 6.022636975017927d
     &     -6*lfh**2*nl + 0.10489139902755974d0*lfr*nl
      help(3,16) = 6.372283162909986d0 - 3.8677962536025206d0*dlxm1 +
     &     1.6261419647185797d0*dlxm1**2 - 1.3895093253968254d0*lth -
     &     0.17560191198348712d0*nl + 0.03853110277367814d0*dlxm1*nl +
     &     0.000021352985638699925d0*dlxm1**2*nl + 0.16487928127981963d0
     &     *z2 - 0.000021352985638699925d0*nl*z2
      help(3,16) = help(3,16) + 3.3820116673163954d0*lfh -
     &     1.4452191645889125d0*dlxm1*lfh + 0.0024515594699418227d0*lfh
     &     **2 - 1.9699255151579862d0*lfr - 0.01926555138683907d0*lfh*nl
     &     - 0.000021352985638699925d0*dlxm1*lfh*nl + 5.338246409674981d
     &     -6*lfh**2*nl + 0.11938942516109008d0*lfr*nl

C-}}}

      do k=0,nsoftmt(2,1)
         sum = 0.d0
         do j=2,nmtlim(2,1),2
            sum = sum + (mh/mt)**j * help(j/2,k)
         enddo
         helpmt(k) = sum
      enddo

C$$$      modified = 1
c..   this is  G(x) = sigma/xt^ncat2mt :
      sum = 0.d0
      do k=0,nsoftmt(2,1)
c..  this is now taken care of in sgg2exp:
c$$$         sum = bininv(ncat2mt,k+1) * dcoefs2mt(1.d0,dlxm1,dlxm1**2,dlxm1
c$$$     &        **3)
         sum = 0.d0
         do i=0,k
            sum = sum + bininv(ncat2,i) * helpmt(k-i)
         enddo
         helpx(k) = sum
      enddo

      sgg2mtexp = 0.d0
      do k=0,nsoftmt(2,1)
         sgg2mtexp = sgg2mtexp + xm1**k * helpx(k)
      enddo

      sgg2mtexp = xt**ncat2 * sgg2mtexp

      return
      end

C-}}}
C-{{{ function sqg2mtexp(xt)

      real*8 function sqg2mtexp(xt)
C
C
      implicit none
      integer i,j,k
      real*8 xt,xm1,dlxm1,sum,dlm1os,nl,bininv
      real*8 help(10,0:20),helpmt(0:20),helpx(0:20)
      include '../commons/common-errors.f'
      include '../commons/common-expand.f'
      include '../commons/common-keys.f'
      include '../commons/common-consts.f'
      include '../commons/common-vars.f'

      do i=0,20
         do j=1,10
            help(j,i) = 0.d0
         enddo
      enddo

      if (lpseudo) stop 'sqg2mtexp'
      if (nmtlim(2,2).gt.6) stop 'sqg2mtexp'
      if (nsoftmt(2,2).gt.16) stop 'sqg2mtexp'

      xm1 = 1.d0-xt
      dlxm1 = dlog(xm1)
 
      nl=nf
      dlm1os = - lth

C-{{{ 1/mt^2:

      help(1,0) = 0.2154320987654321d0 + (8249*dlxm1)/3240.d0 + (119
     &     *dlxm1**2)/432.d0 + (2569*dlxm1**3)/3240.d0 + (91*nl)/4860.d0
     &     - (7*dlxm1*nl)/90.d0 + (7*dlxm1**2*nl)/1080.d0 + (203*z2)
     &     /360.d0- (35*dlxm1*z2)/54.d0 + (2177*z3)/1080.d0
      help(1,0) = help(1,0) + (-2183.d0*lfh)/1620.d0 - (7*dlxm1*lfh)
     &     /180.d0-(217*dlxm1**2.d0*lfh)/180.d0 - (7.d0*lfh**2)/40.d0 +
     &     (217*dlxm1*lfh**2)/540.d0 - (77*lfr)/120.d0 - (77*dlxm1
     &     *lfr)/60.d0 +(77.d0*lfh*lfr)/120.d0 + (7.d0*lfh*nl)/162.d0 -
     &     (7*dlxm1*lfh*nl)/270.d0 + (7*lfh**2*nl)/540.d0 + (7*lfr
     &     *nl)/180.d0 + (7*dlxm1*lfr*nl)/90.d0 - (7*lfh*lfr*nl)/180.d0
     &     + (35.d0*lfh*z2)/108.d0
      help(1,1) = -8.797510288065844d0 + (22553*dlxm1)/3240.d0 - (22
     &     *dlxm1**2)/9.d0 + (1441*lth)/3240.d0 + (44*nl)/405.d0 +
     &     (dlxm1*nl)/90.d0 +(469*z2)/1080.d0
      help(1,1) = help(1,1) + (-508.d0*lfh)/135.d0 + (5*dlxm1*lfh)
     &     /2.d0 -(217.d0*lfh**2)/540.d0 + (33*lfr)/20.d0 + (2.d0*lfh
     &     *nl)/135.d0 -(lfr*nl)/10.d0
      help(1,2) = -6.231075102880658d0 + (1837*dlxm1)/324.d0 - (1373
     &     *dlxm1**2)/1080.d0 + (2569.d0*dlxm1**3)/3240.d0 + (1441*lth)
     &     /3240.d0 +(1829*nl)/9720.d0 - (13.d0*dlxm1*nl)/90.d0 + (7.d0
     &     *dlxm1**2*nl)/1080.d0 + (49*z2)/270.d0 - (35.d0*dlxm1*z2)
     &     /54.d0 + (2177*z3)/1080.d0
      help(1,2) = help(1,2) + (-5981.d0*lfh)/1620.d0 + (451.d0*dlxm1
     &     *lfh)/270.d0 -(217.d0*dlxm1**2.d0*lfh)/180.d0 - (56.d0*lfh
     &     **2)/135.d0 +(217.d0*dlxm1*lfh**2)/540.d0 + (121*lfr)
     &     /120.d0 - (77.d0*dlxm1*lfr)/60.d0 + (77.d0*lfh*lfr)/120.d0 +
     &     (89.d0*lfh*nl)/810.d0- (7.d0*dlxm1*lfh*nl)/270.d0 + (7.d0
     &     *lfh**2*nl)/540.d0 - (11*lfr*nl)/180.d0 +(7.d0*dlxm1*lfr*nl)
     &     /90.d0 -(7.d0*lfh*lfr*nl)/180.d0+ (35.d0*lfh*z2)/108.d0
      help(1,3) = 0.8338923182441701d0 - (1061.d0*dlxm1)/3240.d0 +
     &     (304.d0*dlxm1**2)/405.d0 + (1441*lth)/2430.d0 + (14*nl)
     &     /1215.d0 -(8.d0*dlxm1*nl)/405.d0 - (91*z2)/90.d0
      help(1,3) = help(1,3) + (-1961.d0*lfh)/4860.d0 - (239.d0*dlxm1
     &     *lfh)/405.d0 +(217.d0*lfh**2)/1620.d0 + (22*lfr)/45.d0 +
     &     (8.d0*lfh*nl)/405.d0 - (4*lfr*nl)/135.d0
      help(1,4) = 0.13866662379972566d0 - (2077.d0*dlxm1)/12960.d0 + (87
     &     .d0*dlxm1**2)/160.d0 + (1441*lth)/2430.d0 + (53*nl)/1296.d0 -
     &     (113.d0*dlxm1*nl)/3240.d0 - (8323*z2)/6480.d0
      help(1,4) = help(1,4) + (-11701.d0*lfh)/19440.d0 - (145.d0
     &     *dlxm1*lfh)/324.d0+ (49.d0*lfh**2)/270.d0 + (1243*lfr)
     &     /1440.d0 + (113.d0*lfh*nl)/3240.d0 -(113*lfr*nl)/2160.d0
      help(1,5) = -0.7525683984910837d0 + (334453.d0*dlxm1)/486000.d0 +
     &     (16.d0*dlxm1**2)/81.d0 + (1441*lth)/2430.d0 + (47*nl)/1215.d0
     &     - (82.d0*dlxm1*nl)/2025.d0 - (2261*z2)/2025.d0
      help(1,5) = help(1,5) + (-280607.d0*lfh)/243000.d0 - (169.d0*dlxm1
     &     *lfh)/1350.d0 + (427.d0*lfh**2)/3240.d0 + (451*lfr)/450.d0
     &     + (82.d0*lfh*nl)/2025.d0 - (41*lfr*nl)/675.d0
      help(1,6) = -0.7894962362825789d0 + (815629.d0*dlxm1)/972000.d0 +
     &     (1271.d0*dlxm1**2)/64800.d0 + (1441*lth)/2430.d0 + (3137*nl)
     &     /97200.d0- (47.d0*dlxm1*nl)/1080.d0 - (33523*z2)/32400.d0
      help(1,6) = help(1,6) + (-648211.d0*lfh)/486000.d0 + (323.d0*dlxm1
     &     *lfh)/8100.d0 + (217.d0*lfh**2)/2025.d0 + (517*lfr)/480.d0
     &     + (47.d0*lfh*nl)/1080.d0 - (47*lfr*nl)/720.d0
      help(1,7) = -0.7319213312897175d0 + (1441297.d0*dlxm1)/1.701d6 -
     &     (7.d0*dlxm1**2)/75.d0 + (1441*lth)/2430.d0 + (154*nl)/6075.d0
     &     -(92.d0*dlxm1*nl)/2025.d0 - (3979*z2)/4050.d0
      help(1,7) = help(1,7) + (-1209773.d0*lfh)/850500.d0 + (293.d0
     &     *dlxm1*lfh)/2025.d0 + (247.d0*lfh**2)/2700.d0 + (253*lfr)
     &     /225.d0 + (92.d0*lfh*nl)/2025.d0 - (46*lfr*nl)/675.d0
      help(1,8) = -0.6568099661482392d0 + (293999.d0*dlxm1)/362880.d0 -
     &     (4487.d0*dlxm1**2)/25920.d0 + (1441*lth)/2430.d0 + (50933*nl)
     &     /2.7216d6 -(101.d0*dlxm1*nl)/2160.d0 - (2449*z2)/2592.d0
      help(1,8) = help(1,8) + (-167239.d0*lfh)/113400.d0 + (709.d0*dlxm1
     &     *lfh)/3240.d0 + (13.d0*lfh**2)/162.d0 + (1111*lfr)/960.d0
     &     + (101.d0*lfh*nl)/2160.d0 - (101*lfr*nl)/1440.d0
      help(1,9) = -0.5798612879736943d0 + (68591.d0*dlxm1)/90720.d0 -
     &     (1133.d0*dlxm1**2)/4860.d0 + (1441*lth)/2430.d0 + (6403*nl)
     &     /510300.d0- (58.d0*dlxm1*nl)/1215.d0 - (4451*z2)/4860.d0
      help(1,9) = help(1,9) + (-18475411.d0*lfh)/1.22472d7 + (89.d0
     &     *dlxm1*lfh)/324.d0 + (1393.d0*lfh**2)/19440.d0 + (319*lfr)
     &     /270.d0 +(58.d0*lfh*nl)/1215.d0 - (29*lfr*nl)/405.d0
      help(1,10) = -0.5054496534120335d0 + (18934541.d0*dlxm1)/2.7216d7
     &     -(269.d0*dlxm1**2)/960.d0 + (1441*lth)/2430.d0 + (93361*nl)
     &     /1.3608d7- (1571.d0*dlxm1*nl)/32400.d0 - (57841*z2)/64800.d0
      help(1,10) = help(1,10) + (-1116449.d0*lfh)/729000.d0 + (5161.d0
     &     *dlxm1*lfh)/16200.d0 + (7.d0*lfh**2)/108.d0 + (17281*lfr)
     &     /14400.d0 +(1571.d0*lfh*nl)/32400.d0 - (1571*lfr*nl)/21600.d0
      help(1,11) = -0.4348763253198342d0 + (587002153.d0*dlxm1)
     &     /9.261945d8-(21268.d0*dlxm1**2)/66825.d0 + (1441*lth)/2430.d0
     &     + (454*nl)/280665.d0- (656.d0*dlxm1*nl)/13365.d0 - (12971*z2)
     &     /14850.d0
      help(1,11) = help(1,11) + (-273020461.d0*lfh)/1.76418d8 + (23663
     &     .d0*dlxm1*lfh)/66825.d0 + (15827.d0*lfh**2)/267300.d0 +
     &     (164*lfr)/135.d0+ (656.d0*lfh*nl)/13365.d0 - (328*lfr*nl)
     &     /4455.d0
      help(1,12) = -0.36840761609326317d0 + (1413909001.d0*dlxm1)
     &     /2.469852d9- (249289.d0*dlxm1**2)/712800.d0 + (1441*lth)
     &     /2430.d0 - (1450117*nl)/4.49064d8 - (803.d0*dlxm1*nl)
     &     /16200.d0 - (101857*z2)/118800.d0
      help(1,12) = help(1,12) + (-1100225459.d0*lfh)/7.05672d8 + (34171
     &     .d0*dlxm1*lfh)/89100.d0 + (2429.d0*lfh**2)/44550.d0 +
     &     (8833*lfr)/7200.d0+ (803.d0*lfh*nl)/16200.d0 - (803*lfr*nl)
     &     /10800.d0
      help(1,13) = -0.3059246594479495d0 + (428120453.d0*dlxm1)
     &     /8.34809976d8- (269.d0*dlxm1**2)/715.d0 + (1441*lth)/2430.d0
     &     - (563767*nl)/7.29729d7 - (2894.d0*dlxm1*nl)/57915.d0 - (9772
     &     *z2)/11583.d0
      help(1,13) = help(1,13) + (-692364271.d0*lfh)/4.416984d8 + (47293
     &     .d0*dlxm1*lfh)/115830.d0 + (1561.d0*lfh**2)/30888.d0 +
     &     (1447*lfr)/1170.d0+ (2894.d0*lfh*nl)/57915.d0 - (1447*lfr*nl)
     &     /19305.d0
      help(1,14) = -0.24716663108058187d0 + (3455906677.d0*dlxm1)
     &     /7.5891816d9- (67199.d0*dlxm1**2)/168480.d0 + (1441*lth)
     &     /2430.d0 - (13909529*nl)/1.1675664d9 - (163.d0*dlxm1*nl)
     &     /3240.d0 - (70069*z2)/84240.d0
      help(1,14) = help(1,14) + (-23885376881.d0*lfh)/1.51783632d10 +
     &     (67.d0*dlxm1*lfh)/156.d0 + (248.d0*lfh**2)/5265.d0 + (1793
     &     *lfr)/1440.d0 +(163.d0*lfh*nl)/3240.d0 - (163*lfr*nl)/2160.d0
      help(1,15) = -0.19183068242947635d0 + (3797150017.d0*dlxm1)
     &     /9.486477d9- (2203.d0*dlxm1**2)/5265.d0 + (1441*lth)/2430.d0
     &     - (962501*nl)/6.081075d7 - (148.d0*dlxm1*nl)/2925.d0 - (43247
     &     *z2)/52650.d0
      help(1,15) = help(1,15) + (-14971108367.d0*lfh)/9.486477d9 +
     &     (11789.d0*dlxm1*lfh)/26325.d0 + (929.d0*lfh**2)/21060.d0 +
     &     (407*lfr)/325.d0 +(148.d0*lfh*nl)/2925.d0 - (74*lfr*nl)
     &     /975.d0
      help(1,16) = -0.1396146036656257d0 + (16231992173.d0*dlxm1)
     &     /4.6702656d10 - (4181.d0*dlxm1**2)/9600.d0 + (1441*lth)
     &     /2430.d0-(18214211*nl)/9.3405312d8 - (659.d0*dlxm1*nl)
     &     /12960.d0 -(105269*z2)/129600.d0
      help(1,16) = help(1,16) + (-6154808677.d0*lfh)/3.891888d9 + (15029
     &     .d0*dlxm1*lfh)/32400.d0 + (28.d0*lfh**2)/675.d0 + (7249
     &     *lfr)/5760.d0 +(659.d0*lfh*nl)/12960.d0 - (659*lfr*nl)
     &     /8640.d0

C-}}}
C-{{{ 1/mt^4:

      help(2,0) = 0.04671259553203998d0 + (96149.d0*dlxm1)/259200.d0 +
     &     (26231.d0*dlxm1**2)/725760.d0 + (566281.d0*dlxm1**3)/5.4432d6
     &     + (20059.d0*nl)/8.1648d6 - (1543.d0*dlxm1*nl)/151200.d0 +
     &     (1543.d0*dlxm1**2*nl)/1.8144d6 + (44747.d0*z2)/604800.d0 -
     &     (1543.d0*dlxm1*z2)/18144.d0 + (479873.d0*z3)/1.8144d6
      help(2,0) = help(2,0) + (-177133.d0*lfh)/907200.d0 - (1543.d0
     &     *dlxm1*lfh)/302400.d0 - (47833.d0*dlxm1**2*lfh)/302400.d0 -
     &     (1543.d0*lfh**2)/67200.d0 + (47833.d0*dlxm1*lfh**2)/907200.d0
     &     - (16973.d0*lfr)/201600.d0 - (16973.d0*dlxm1*lfr)/100800.d0 +
     &     (16973.d0*lfh*lfr)/201600.d0 + (1543.d0*lfh*nl)/272160.d0 -
     &     (1543.d0*dlxm1*lfh*nl)/453600.d0 + (1543.d0*lfh**2*nl)
     &     /907200.d0 + (1543.d0*lfr*nl)/302400.d0 + (1543.d0*dlxm1*lfr
     &     *nl)/151200.d0 - (1543.d0*lfh*lfr*nl)/302400.d0 + (1543.d0
     &     *lfh*z2)/36288.d0
      help(2,1) = -1.3485102058313037d0 + (261713.d0*dlxm1)/272160.d0 -
     &     (203723.d0*dlxm1**2)/604800.d0 + (178699.d0*lth)/2.7216d6 +
     &     (1499.d0*nl)/85050.d0 + (11.d0*dlxm1*nl)/56700.d0 + (7529.d0
     &     *z2)/181440.d0
      help(2,1) = help(2,1) + (-95659.d0*lfh)/181440.d0 + (78121.d0
     &     *dlxm1*lfh)/226800.d0 - (47833.d0*lfh**2)/907200.d0 +
     &     (49951.d0*lfr)/201600.d0 + (97.d0*lfh*nl)/30240.d0 - (4541.d0
     &     *lfr*nl)/302400.d0
      help(2,2) = -0.7323715028449651d0 + (404629.d0*dlxm1)/604800.d0 -
     &     (59789.d0*dlxm1**2)/453600.d0 + (566281.d0*dlxm1**3)/5.4432d6
     &     + (10897.d0*lth)/1.8144d6 + (2356.d0*nl)/127575.d0 - (4951.d0
     &     *dlxm1*nl)/302400.d0 + (1543.d0*dlxm1**2*nl)/1.8144d6 +
     &     (11641.d0*z2)/259200.d0 - (1543.d0*dlxm1*z2)/18144.d0 +
     &     (479873.d0*z3)/1.8144d6
      help(2,2) = help(2,2) + (-382267.d0*lfh)/907200.d0 + (168401.d0
     &     *dlxm1*lfh)/907200.d0 - (47833.d0*dlxm1**2*lfh)/302400.d0 -
     &     (1543.d0*lfh**2)/28350.d0 + (47833.d0*dlxm1*lfh**2)/907200.d0
     &     + (27599.d0*lfr)/403200.d0 - (16973.d0*dlxm1*lfr)/100800.d0 +
     &     (16973.d0*lfh*lfr)/201600.d0 + (6443.d0*lfh*nl)/544320.d0 -
     &     (1543.d0*dlxm1*lfh*nl)/453600.d0 + (1543.d0*lfh**2*nl)
     &     /907200.d0 - (2509.d0*lfr*nl)/604800.d0 + (1543.d0*dlxm1*lfr
     &     *nl)/151200.d0 - (1543.d0*lfh*lfr*nl)/302400.d0 + (1543.d0
     &     *lfh*z2)/36288.d0
      help(2,3) = 0.48217910741114006d0 - (83213.d0*dlxm1)/272160.d0 +
     &     (121939.d0*dlxm1**2)/680400.d0 - (56737.d0*lth)/1.63296d6 -
     &     (17047.d0*nl)/2.0412d6 + (221.d0*dlxm1*nl)/64800.d0 -
     &     (109061.d0*z2)/1.3608d6
      help(2,3) = help(2,3) + (1457.d0*lfh)/9072.d0 - (30221.d0*dlxm1
     &     *lfh)/194400.d0 + (47833.d0*lfh**2)/2.7216d6 - (2431.d0*lfr)
     &     /28800.d0 - (221.d0*lfh*nl)/64800.d0 + (221.d0*lfr*nl)
     &     /43200.d0
      help(2,4) = 0.6882747903784714d0 - (1385759.d0*dlxm1)/3.1104d6 +
     &     (1536433.d0*dlxm1**2)/7.2576d6 - (3529489.d0*lth)/3.26592d7 -
     &     (210419.d0*nl)/2.17728d7 + (383.d0*dlxm1*nl)/64800.d0 -
     &     (266083.d0*z2)/3.6288d6
      help(2,4) = help(2,4) + (6391409.d0*lfh)/2.17728d7 - (4369.d0
     &     *dlxm1*lfh)/22400.d0 + (1543.d0*lfh**2)/64800.d0 - (4213.d0
     &     *lfr)/28800.d0 - (383.d0*lfh*nl)/64800.d0 + (383.d0*lfr*nl)
     &     /43200.d0
      help(2,5) = 0.8347371868497055d0 - (12010669.d0*dlxm1)/2.5515d7 +
     &     (614807.d0*dlxm1**2)/2.7216d6 - (987373.d0*lth)/5.4432d6 -
     &     (60109.d0*nl)/4.6656d6 + (131423.d0*dlxm1*nl)/1.3608d7 -
     &     (117311.d0*z2)/1.3608d7
      help(2,5) = help(2,5) + (310131239.d0*lfh)/8.1648d8 - (957307.d0
     &     *dlxm1*lfh)/4.536d6 + (94123.d0*lfh**2)/5.4432d6 -
     &     (1445653.d0*lfr)/6.048d6 - (131423.d0*lfh*nl)/1.3608d7 +
     &     (131423.d0*lfr*nl)/9.072d6
      help(2,6) = 1.0608574364424697d0 - (102882121.d0*dlxm1)/1.8144d8 +
     &     (4077437.d0*dlxm1**2)/1.5552d7 - (8318987.d0*lth)/3.26592d7 -
     &     (331789.d0*nl)/2.17728d7 + (37409.d0*dlxm1*nl)/2.7216d6 +
     &     (812881.d0*z2)/1.8144d7
      help(2,6) = help(2,6) + (838261717.d0*lfh)/1.63296d9 - (6741001.d0
     &     *dlxm1*lfh)/2.7216d7 + (47833.d0*lfh**2)/3.402d6 - (411499.d0
     &     *lfr)/1.2096d6 - (37409.d0*lfh*nl)/2.7216d6 + (37409.d0*lfr
     &     *nl)/1.8144d6
      help(2,7) = 1.2781219581337757d0 - (6675709657.d0*dlxm1)
     &     /1.000188d10+ (4873727.d0*dlxm1**2)/1.5876d7 - (1339217.d0
     &     *lth)/4.0824d6- (632573.d0*nl)/3.81024d7 + (15857.d0*dlxm1
     &     *nl)/882000.d0 +(374389.d0*z2)/3.969d6
      help(2,7) = help(2,7) + (4386293339.d0*lfh)/6.66792d9 - (144982.d0
     &     *dlxm1*lfh)/496125.d0 + (381121.d0*lfh**2)/3.1752d7 -
     &     (174427.d0*lfr)/392000.d0 - (15857.d0*lfh*nl)/882000.d0 +
     &     (15857.d0*lfr*nl)/588000.d0
      help(2,8) = 1.4813148391003998d0 - (48796418677.d0*dlxm1)
     &     /6.4012032d10 + (108560023.d0*dlxm1**2)/3.048192d8 -
     &     (873899.d0*lth)/2.17728d6 - (78073543.d0*nl)/4.572288d9 +
     &     (80881.d0*dlxm1*nl)/3.6288d6 + (4326773.d0*z2)/3.048192d7
      help(2,8) = help(2,8) + (2581496831.d0*lfh)/3.2006016d9 -
     &     (1623151.d0*dlxm1*lfh)/4.7628d6 + (20059.d0*lfh**2)/1.90512d6
     &     - (889691.d0*lfr)/1.6128d6 - (80881.d0*lfh*nl)/3.6288d6 +
     &     (80881.d0*lfr*nl)/2.4192d6
      help(2,9) = 1.6713050769505267d0 - (20400346901.d0*dlxm1)
     &     /2.4004512d10 + (1665197.d0*dlxm1**2)/4.0824d6 - (7751617.d0
     &     *lth)/1.63296d7 - (57520013.d0*nl)/3.429216d9 + (1522841.d0
     &     *dlxm1*nl)/5.71536d7 + (5384657.d0*z2)/2.85768d7
      help(2,9) = help(2,9) + (137895890297.d0*lfh)/1.44027072d11 -
     &     (1865893.d0*dlxm1*lfh)/4.7628d6 + (307057.d0*lfh**2)
     &     /3.26592d7 - (16751251.d0*lfr)/2.54016d7 - (1522841.d0*lfh
     &     *nl)/5.71536d7 + (1522841.d0*lfr*nl)/3.81024d7
      help(2,10) = 1.8495170043895912d0 - (127578539813.d0*dlxm1)
     &     /1.3716864d11 + (191329.d0*dlxm1**2)/414720.d0 - (17897983.d0
     &     *lth)/3.26592d7 - (17193821.d0*nl)/1.08864d9 + (80431.d0
     &     *dlxm1*nl)/2.592d6 + (944113.d0*z2)/4.032d6
      help(2,10) = help(2,10) + (4227456523.d0*lfh)/3.81024d9 -
     &     (2015351.d0*dlxm1*lfh)/4.536d6 + (1543.d0*lfh**2)/181440.d0 -
     &     (884741.d0*lfr)/1.152d6 - (80431.d0*lfh*nl)/2.592d6 +
     &     (80431.d0*lfr*nl)/1.728d6
      help(2,11) = 2.0172438852880097d0 - (6245220445577.d0*dlxm1)
     &     /6.22402704d12 + (28963369.d0*dlxm1**2)/5.6133d7 - (563687.d0
     &     *lth)/907200.d0 - (10943683.d0*nl)/7.69824d8 + (227333.d0
     &     *dlxm1*nl)/6.4152d6 + (6969101.d0*z2)/2.4948d7
      help(2,11) = help(2,11) + (96995665871.d0*lfh)/7.683984d10 -
     &     (111802661.d0*dlxm1*lfh)/2.24532d8 + (498389.d0*lfh**2)
     &     /6.4152d7 - (227333.d0*lfr)/259200.d0 - (227333.d0*lfh*nl)
     &     /6.4152d6 + (227333.d0*lfr*nl)/4.2768d6
      help(2,12) = 2.175574434925768d0 - (8882251708697.d0*dlxm1)
     &     /8.29870272d12 + (684343019.d0*dlxm1**2)/1.197504d9 -
     &     (22687481.d0*lth)/3.26592d7 - (760965979.d0*nl)/6.286896d10 +
     &     (180793.d0*dlxm1*nl)/4.536d6 + (194076131.d0*z2)/5.98752d8
      help(2,12) = help(2,12) + (11747670124093.d0*lfh)/8.29870272d12 -
     &     (165367457.d0*dlxm1*lfh)/2.99376d8 + (535421.d0*lfh**2)
     &     /7.4844d7 - (1988723.d0*lfr)/2.016d6 - (180793.d0*lfh*nl)
     &     /4.536d6 + (180793.d0*lfr*nl)/3.024d6
      help(2,13) = 2.3254160046838925d0 - (52888356677701.d0*dlxm1)
     &     /4.6749358656d13 + (11631637.d0*dlxm1**2)/1.85328d7 -
     &     (2508223.d0*lth)/3.26592d6 - (3109439323.d0*nl)/3.26918592d11
     &     + (5745587.d0*dlxm1*nl)/1.297296d8 + (9564053.d0*z2)
     &     /2.594592d7
      help(2,13) = help(2,13) + (73360155075061.d0*lfh)/4.6749358656d13
     &     - (26266699.d0*dlxm1*lfh)/4.32432d7 + (344089.d0*lfh**2)
     &     /5.189184d7 - (5745587.d0*lfr)/5.2416d6 - (5745587.d0*lfh*nl)
     &     /1.297296d8 + (5745587.d0*lfr*nl)/8.64864d7
      help(2,14) = 2.467528778722068d0 - (30264362218681.d0*dlxm1)
     &     /2.5499650176d13 + (1355782579.d0*dlxm1**2)/1.9813248d9 -
     &     (9158993.d0*lth)/1.08864d7 - (44499956749.d0*nl)
     &     /6.865290432d12 + (464171.d0*dlxm1*nl)/9.5256d6 +
     &     (408996311.d0*z2)/9.906624d8
      help(2,14) = help(2,14) + (43937637300001.d0*lfh)/2.5499650176d13
     &     - (109457249.d0*dlxm1*lfh)/1.651104d8 + (47833.d0*lfh**2)
     &     /7.73955d6 - (5105881.d0*lfr)/4.2336d6 - (464171.d0*lfh*nl)
     &     /9.5256d6 + (464171.d0*lfr*nl)/6.3504d6
      help(2,15) = 2.6025555210889904d0 - (23006328295889.d0*dlxm1)
     &     /1.859349492d13 + (91802083.d0*dlxm1**2)/1.238328d8 -
     &     (1866983.d0*lth)/2.0412d6 - (534604639.d0*nl)/1.7513496d11 +
     &     (1175861.d0*dlxm1*nl)/2.2113d7 + (47148419.d0*z2)/1.03194d8
      help(2,15) = help(2,15) + (26176020928613.d0*lfh)/1.394512119d13 -
     &     (222534863.d0*dlxm1*lfh)/3.09582d8 + (1433447.d0*lfh**2)
     &     /2.476656d8 - (12934471.d0*lfr)/9.828d6 - (1175861.d0*lfh*nl)
     &     /2.2113d7 + (1175861.d0*lfr*nl)/1.4742d7
      help(2,16) = 2.7310450882491932d0 - (78301523773829.d0*dlxm1)
     &     /6.102480384d13 + (115936019.d0*dlxm1**2)/1.45152d8 -
     &     (32266477.d0*lth)/3.26592d7 + (349833391.d0*nl)/4.69421568d11
     &     + (975871.d0*dlxm1*nl)/1.69344d7 + (254407031.d0*z2)
     &     /5.08032d8
      help(2,16) = help(2,16) + (92964921757789.d0*lfh)/4.576860288d13 -
     &     (98433241.d0*dlxm1*lfh)/1.27008d8 + (1543.d0*lfh**2)
     &     /283500.d0 -(10734581.d0*lfr)/7.5264d6 - (975871.d0*lfh*nl)
     &     /1.69344d7 +(975871.d0*lfr*nl)/1.12896d7

C-}}}
C-{{{ 1/mt^6:

      help(3,0) = 0.009131627753982251d0 + 0.058911036225189665d0*dlxm1
     &     + 0.005293761022927689d0*dlxm1**2 + 0.015237727807172252d0
     &     *dlxm1**3 + 0.0003598373505780913d0*nl -
     &     0.0014947089947089946d0*dlxm1*nl + 0.00012455908289241624d0
     &     *dlxm1**2*nl + 0.010836640211640212d0*z2 -
     &     0.012455908289241622d0*dlxm1*z2 + 0.038737874779541444d0*z3
      help(3,0) = help(3,0)  -0.03088794756585762d0*lfh -
     &     0.0007473544973544973d0*dlxm1*lfh - 0.023167989417989417d0
     &     *dlxm1**2*lfh - 0.003363095238095238d0*lfh**2 +
     &     0.007722663139329806d0*dlxm1*lfh**2 - 0.012331349206349207d0
     &     *lfr - 0.024662698412698414d0*dlxm1*lfr +
     &     0.012331349206349207d0*lfh*lfr + 0.0008303938859494415d0*lfh
     &     *nl - 0.0004982363315696649d0*dlxm1*lfh*nl +
     &     0.00024911816578483247d0*lfh**2*nl + 0.0007473544973544973d0
     &     *lfr*nl + 0.0014947089947089946d0*dlxm1*lfr*nl -
     &     0.0007473544973544973d0*lfh*lfr*nl + 0.006227954144620811d0
     &     *lfh*z2
      help(3,1) = -0.21570913547003162d0 + 0.14395655129335685d0*dlxm1 -
     &     0.050317460317460316d0*dlxm1**2 + 0.009890450470311582d0*lth
     &     + 0.002786596119929453d0*nl - 0.00004850088183421517d0*dlxm1
     &     *nl + 0.005135582010582011d0*z2
      help(3,1) = help(3,1)  -0.07925925925925927d0*lfh +
     &     0.05145061728395062d0*dlxm1*lfh - 0.007722663139329806d0*lfh
     &     **2 + 0.03819444444444445d0*lfr + 0.0005467372134038801d0*lfh
     &     *nl - 0.0023148148148148147d0*lfr*nl
      help(3,2) = -0.09997527058662971d0 + 0.0985420069776882d0*dlxm1 -
     &     0.017806988536155203d0*dlxm1**2 + 0.015237727807172252d0
     &     *dlxm1**3 - 0.0009531709288653733d0*lth +
     &     0.002433617479913776d0*nl - 0.002290564373897707d0*dlxm1*nl +
     &     0.00012455908289241624d0*dlxm1**2*nl +
     &     0.0072503306878306875d0*z2 - 0.012455908289241622d0*dlxm1*z2
     &     + 0.038737874779541444d0*z3
      help(3,2) = help(3,2)  -0.061304614232524285d0*lfh +
     &     0.025791446208112873d0*dlxm1*lfh - 0.023167989417989417d0
     &     *dlxm1**2*lfh - 0.007971781305114639d0*lfh**2 +
     &     0.007722663139329806d0*dlxm1*lfh**2 + 0.007366071428571428d0
     &     *lfr - 0.024662698412698414d0*dlxm1*lfr +
     &     0.012331349206349207d0*lfh*lfr + 0.001626249265138154d0*lfh
     &     *nl - 0.0004982363315696649d0*dlxm1*lfh*nl +
     &     0.00024911816578483247d0*lfh**2*nl - 0.0004464285714285714d0
     &     *lfr*nl + 0.0014947089947089946d0*dlxm1*lfr*nl -
     &     0.0007473544973544973d0*lfh*lfr*nl + 0.006227954144620811d0
     &     *lfh*z2
      help(3,3) = 0.06048655153247856d0 - 0.02981095066627474d0*dlxm1 +
     &     0.023073559670781892d0*dlxm1**2 - 0.00022946673525377228d0
     &     *lth - 0.0006501077797374093d0*nl + 0.0002616108171663727d0
     &     *dlxm1*nl - 0.013940696649029983d0*z2
      help(3,3) = help(3,3) + 0.013542891436409955d0*lfh -
     &     0.0196766607877719d0*dlxm1*lfh + 0.0025742210464432687d0*lfh
     &     **2 - 0.0064748677248677245d0*lfr - 0.0002616108171663727d0
     &     *lfh*nl + 0.0003924162257495591d0*lfr*nl
      help(3,4) = 0.026259726151691816d0 - 0.005232299015285127d0*dlxm1
     &     + 0.01706900352733686d0*dlxm1**2 + 0.004323627033117774d0*lth
     &     + 0.0004112470605526161d0*nl - 0.00016534391534391533d0*dlxm1
     &     *nl - 0.019407793209876543d0*z2
      help(3,4) = help(3,4)  -0.00010967813051146385d0*lfh -
     &     0.015164241622574955d0*dlxm1*lfh + 0.003487654320987654d0*lfh
     &     **2 + 0.004092261904761905d0*lfr + 0.00016534391534391533d0
     &     *lfh*nl - 0.000248015873015873d0*lfr*nl
      help(3,5) = -0.05962950046162155d0 + 0.06179078789437586d0*dlxm1 +
     &     0.0008760655496766608d0*dlxm1**2 + 0.01895798611111111d0*lth
     &     + 0.0016803742896335488d0*nl - 0.0009641387419165197d0*dlxm1
     &     *nl - 0.020988793356848914d0*z2
      help(3,5) = help(3,5)  -0.04334652165392906d0*lfh +
     &     0.00001146384479717813d0*dlxm1*lfh + 0.0025327013521457965d0
     &     *lfh**2 + 0.023862433862433863d0*lfr +
     &     0.0009641387419165197d0*lfh*nl - 0.0014462081128747794d0*lfr
     &     *nl
      help(3,6) = -0.17228949408407052d0 + 0.14138927346658828d0*dlxm1 -
     &     0.019592849794238684d0*dlxm1**2 + 0.04367361049872624d0*lth +
     &     0.003302727562218303d0*nl - 0.002267636684303351d0*dlxm1*nl -
     &     0.028814502498530275d0*z2
      help(3,6) = help(3,6)  -0.10259054845189104d0*lfh +
     &     0.01937338330393886d0*dlxm1*lfh + 0.002059376837154615d0*lfh
     &     **2 + 0.05612400793650794d0*lfr + 0.002267636684303351d0*lfh
     &     *nl - 0.0034014550264550264d0*lfr*nl
      help(3,7) = -0.32014640145206275d0 + 0.24111354810295665d0*dlxm1 -
     &     0.04632357016880827d0*dlxm1**2 + 0.07847050019596316d0*lth +
     &     0.005128080120937264d0*nl - 0.004104308390022676d0*dlxm1*nl -
     &     0.041803036029226505d0*z2
      help(3,7) = help(3,7)  -0.18304256064859806d0*lfh +
     &     0.04478634416729655d0*dlxm1*lfh + 0.0017580624842529603d0*lfh
     &     **2 + 0.10158163265306122d0*lfr + 0.004104308390022676d0*lfh
     &     *nl - 0.006156462585034014d0*lfr*nl
      help(3,8) = -0.5007726326779248d0 + 0.36070967351887845d0*dlxm1 -
     &     0.07992717650331738d0*dlxm1**2 + 0.12334865520282187d0*lth +
     &     0.007013535017916631d0*nl - 0.00648423721340388d0*dlxm1*nl -
     &     0.059663459519610315d0*z2
      help(3,8) = help(3,8)  -0.28564125616259145d0*lfh +
     &     0.07681857310825564d0*dlxm1*lfh + 0.0015421600739061057d0*lfh
     &     **2 + 0.16048487103174602d0*lfr + 0.00648423721340388d0*lfh
     &     *nl - 0.00972635582010582d0*lfr*nl
      help(3,9) = -0.7115297178606778d0 + 0.49909549333891895d0*dlxm1 -
     &     0.12066143689986282d0*dlxm1**2 + 0.17830807551930236d0*lth +
     &     0.008838894954415236d0*nl - 0.009411970549536687d0*dlxm1*nl -
     &     0.0822823846616836d0*z2
      help(3,9) = help(3,9)  -0.4106775977019098d0*lfh +
     &     0.11570851179978164d0*dlxm1*lfh + 0.001377069860866157d0*lfh
     &     **2 + 0.232946271101033d0*lfr + 0.009411970549536687d0*lfh*nl
     &     - 0.01411795582430503d0*lfr*nl
      help(3,10) = -0.9501289742477343d0 + 0.6551551482904547d0*dlxm1 -
     &     0.16865743496472663d0*dlxm1**2 + 0.24334876114540466d0*lth +
     &     0.01050291223999888d0*nl - 0.012889880952380953d0*dlxm1*nl -
     &     0.10960405643738977d0*z2
      help(3,10) = help(3,10)  -0.5582720817673777d0*lfh +
     &     0.16157716049382717d0*dlxm1*lfh + 0.0012455908289241624d0*lfh
     &     **2 + 0.31902455357142856d0*lfr + 0.012889880952380953d0*lfh
     &     *nl - 0.019334821428571427d0*lfr*nl
      help(3,11) = -1.2146023339956005d0 + 0.8278643693776433d0*dlxm1 -
     &     0.22399035549498514d0*dlxm1**2 + 0.31847071208112876d0*lth +
     &     0.011918876872360118d0*nl - 0.016919334437852956d0*dlxm1*nl -
     &     0.14159666105499438d0*z2
      help(3,11) = help(3,11)  -0.7284840325202058d0*lfh +
     &     0.21449389841982436d0*dlxm1*lfh + 0.0011378912582616287d0*lfh
     &     **2 + 0.41875352733686066d0*lfr + 0.016919334437852956d0*lfh
     &     *nl - 0.025379001656779435d0*lfr*nl
      help(3,12) = -1.5032353250670651d0 + 1.0163019816552725d0*dlxm1 -
     &     0.2867070339639784d0*dlxm1**2 + 0.40367392832647464d0*lth +
     &     0.013011262213764418d0*nl - 0.021501175778953555d0*dlxm1*nl -
     &     0.1782401845839346d0*z2
      help(3,12) = help(3,12)  -0.9213460410267594d0*lfh +
     &     0.27450197076585964d0*dlxm1*lfh + 0.001047806103361659d0*lfh
     &     **2 + 0.5321541005291005d0*lfr + 0.021501175778953555d0*lfh
     &     *nl - 0.032251763668430335d0*lfr*nl
      help(3,13) = -1.8145129512556706d0 + 1.2196393582026d0*dlxm1 -
     &     0.3568384431926099d0*dlxm1**2 + 0.4989584098814423d0*lth +
     &     0.013713305800607388d0*nl - 0.026635956635956637d0*dlxm1*nl -
     &     0.21952116941700275d0*z2
      help(3,13) = help(3,13)  -1.1368773772647411d0*lfh +
     &     0.34163000579667246d0*dlxm1*lfh + 0.0009712124295457628d0*lfh
     &     **2 + 0.6592399267399267d0*lfr + 0.026635956635956637d0*lfh
     &     *nl - 0.039953934953934955d0*lfr*nl
      help(3,14) = -2.1470796383826145d0 + 1.4371269641776123d0*dlxm1 -
     &     0.4344060135925215d0*dlxm1**2 + 0.6043241567460318d0*lth +
     &     0.01396525564761424d0*nl - 0.03232405307802133d0*dlxm1*nl -
     &     0.26543012533835947d0*z2
      help(3,14) = help(3,14)  -1.375090041178375d0*lfh +
     &     0.4158978356299785d0*dlxm1*lfh + 0.0009052205877602703d0*lfh
     &     **2 + 0.800020313681028d0*lfr + 0.03232405307802133d0*lfh*nl
     &     - 0.048486079617031996d0*lfr*nl
      help(3,15) = -2.4997096002294388d0 + 1.6680822273952394d0*dlxm1 -
     &     0.51942510869495d0*dlxm1**2 + 0.719771168920243d0*lth +
     &     0.013713075235562007d0*nl - 0.038565730565730566d0*dlxm1*nl -
     &     0.31596011719027595d0*z2
      help(3,15) = help(3,15)  -1.635991795989521d0*lfh +
     &     0.49731969558953687d0*dlxm1*lfh + 0.0008477317802714628d0*lfh
     &     **2 + 0.9545018315018315d0*lfr + 0.038565730565730566d0*lfh
     &     *nl - 0.05784859584859585d0*lfr*nl
      help(3,16) = -2.871284539421895d0 + 1.9118794342247245d0*dlxm1 -
     &     0.6119070629409171d0*dlxm1**2 + 0.8452994464040761d0*lth +
     &     0.012907466974596014d0*nl - 0.045361181972789114d0*dlxm1*nl -
     &     0.3711059342718569d0*z2
      help(3,16) = help(3,16)  -1.9195878115285174d0*lfh +
     &     0.5859061004031242d0*dlxm1*lfh + 0.0007971781305114639d0*lfh
     &     **2 + 1.1226892538265305d0*lfr + 0.045361181972789114d0*lfh
     &     *nl - 0.06804177295918368d0*lfr*nl

C-}}}

      do k=0,nsoftmt(2,2)
         sum = 0.d0
         do j=2,nmtlim(2,2),2
            sum = sum + (mh/mt)**j * help(j/2,k)
         enddo
         helpmt(k) = sum
      enddo

C$$$      modified = 1
      sum = 0.d0
c..   this is  G(x) = sigma/xt^ncat2mt :
      do k=0,nsoftmt(2,2)
         sum = 0.d0
         do i=0,k
            sum = sum + bininv(ncat2,i) * helpmt(k-i)
         enddo
         helpx(k) = sum
      enddo

      sqg2mtexp = 0.d0
      do k=0,nsoftmt(2,2)
         sqg2mtexp = sqg2mtexp + xm1**k * helpx(k)
      enddo

      sqg2mtexp = xt**ncat2 * sqg2mtexp

      return
      end

C-}}}
C-{{{ function sqqb2mtexp(xt)

      real*8 function sqqb2mtexp(xt)
C
C
      implicit none
      integer i,j,k
      real*8 xt,xm1,dlxm1,sum,dlm1os,nl,bininv
      real*8 help(10,0:20),helpmt(0:20),helpx(0:20)
      include '../commons/common-expand.f'
      include '../commons/common-keys.f'
      include '../commons/common-consts.f'
      include '../commons/common-vars.f'
      include '../commons/common-errors.f'

      do i=0,20
         do j=1,10
            help(j,i) = 0.d0
         enddo
      enddo

      if (lpseudo) stop 'sqqb2mtexp'
      if (nmtlim(2,3).gt.6) stop 'sqqb2mtexp'
      if (nsoftmt(2,3).gt.16) stop 'sqqb2mtexp'

      xm1 = 1.d0-xt
      dlxm1 = dlog(xm1)
 
      nl=nf
      dlm1os = - lth

C-{{{ 1/mt^2:

      help(1,0) = 0
      help(1,0) = help(1,0) + 0
      help(1,1) = 0.25925925925925924d0 - (28.d0*dlxm1)/135.d0 + (28.d0
     &     *dlxm1**2)/135.d0 - (28.d0*z2)/135.d0
      help(1,1) = help(1,1) + (14.d0*lfh)/135.d0 - (28.d0*dlxm1*lfh)
     &     /135.d0 + (7*lfh**2)/135.d0
      help(1,2) = 0.842798353909465d0 - (4*dlxm1)/15.d0 + (14.d0*dlxm1
     &     **2)/135.d0 - (14.d0*z2)/135.d0
      help(1,2) = help(1,2) + (2*lfh)/15.d0 - (14.d0*dlxm1*lfh)/135.d0 +
     &     (7*lfh**2)/270.d0
      help(1,3) = 14.010708733424783d0 - (24542.d0*dlxm1)/3645.d0 +
     &     (2102.d0*dlxm1**2)/1215.d0 - (2882.d0*lth)/3645.d0 - (32.d0
     &     *nl)/81.d0 + (16.d0*dlxm1*nl)/135.d0 - (3238.d0*z2)/1215.d0
      help(1,3) = help(1,3) + (568.d0*lfh)/135.d0 - (52.d0*dlxm1*lfh)
     &     /45.d0 + (7*lfh**2)/135.d0 - (44.d0*lfr)/15.d0 - (8*lfh*nl)
     &     /45.d0 + (8*lfr*nl)/45.d0
      help(1,4) = 4.063497942386832d0 - (19751.d0*dlxm1)/7290.d0 +
     &     (437.d0*dlxm1**2)/405.d0 - (2882.d0*lth)/3645.d0 - (4*nl)
     &     /3645.d0 +(88.d0*dlxm1*nl)/1215.d0 - (73.d0*z2)/45.d0
      help(1,4) = help(1,4) + (33107.d0*lfh)/14580.d0 - (893.d0*dlxm1
     &     *lfh)/1215.d0 + (7*lfh**2)/180.d0 - (242.d0*lfr)/135.d0 -
     &     (44.d0*lfh*nl)/405.d0 + (44.d0*lfr*nl)/405.d0
      help(1,5) = 4.41458683127572d0 - (244018.d0*dlxm1)/91125.d0 +
     &     (712.d0*dlxm1**2)/675.d0 - (2882.d0*lth)/3645.d0 + (574.d0
     &     *nl)/18225.d0 + (88.d0*dlxm1*nl)/1215.d0 - (3236.d0*z2)
     &     /2025.d0
      help(1,5) = help(1,5) + (213434.d0*lfh)/91125.d0 - (4318.d0*dlxm1
     &     *lfh)/6075.d0 + (133.d0*lfh**2)/4050.d0 - (242.d0*lfr)/135.d0
     &     - (44.d0*lfh*nl)/405.d0 + (44.d0*lfr*nl)/405.d0
      help(1,6) = 4.176157247370828d0 - (77971.d0*dlxm1)/30375.d0 +
     &     (2101.d0*dlxm1**2)/2025.d0 - (2882.d0*lth)/3645.d0 + (1246.d0
     &     *nl)/18225.d0 + (88.d0*dlxm1*nl)/1215.d0 - (1067.d0*z2)
     &     /675.d0
      help(1,6) = help(1,6) + (429143.d0*lfh)/182250.d0 - (4213.d0*dlxm1
     &     *lfh)/6075.d0 + (77.d0*lfh**2)/2700.d0 - (242.d0*lfr)/135.d0
     &     - (44.d0*lfh*nl)/405.d0 + (44.d0*lfr*nl)/405.d0
      help(1,7) = 3.8972625290445397d0 - (524653.d0*dlxm1)/212625.d0 +
     &     (2074.d0*dlxm1**2)/2025.d0 - (2882.d0*lth)/3645.d0 + (4222.d0
     &     *nl)/42525.d0 + (88.d0*dlxm1*nl)/1215.d0 - (1058.d0*z2)
     &     /675.d0
      help(1,7) = help(1,7) + (1003643.d0*lfh)/425250.d0 - (4132.d0
     &     *dlxm1*lfh)/6075.d0 + (17.d0*lfh**2)/675.d0 - (242.d0*lfr)
     &     /135.d0 - (44.d0*lfh*nl)/405.d0 + (44.d0*lfr*nl)/405.d0
      help(1,8) = 3.6356526867948826d0 - (135133.d0*dlxm1)/56700.d0 +
     &     (821.d0*dlxm1**2)/810.d0 - (2882.d0*lth)/3645.d0 + (10631.d0
     &     *nl)/85050.d0 + (88.d0*dlxm1*nl)/1215.d0 - (1261.d0*z2)
     &     /810.d0
      help(1,8) = help(1,8) + (268117.d0*lfh)/113400.d0 - (1627.d0*dlxm1
     &     *lfh)/2430.d0 + (73.d0*lfh**2)/3240.d0 - (242.d0*lfr)/135.d0
     &     - (44.d0*lfh*nl)/405.d0 + (44.d0*lfr*nl)/405.d0
      help(1,9) = 3.3984523368865913d0 - (884626.d0*dlxm1)/382725.d0 +
     &     (407.d0*dlxm1**2)/405.d0 - (2882.d0*lth)/3645.d0 + (37439.d0
     &     *nl)/255150.d0 + (88.d0*dlxm1*nl)/1215.d0 - (209.d0*z2)
     &     /135.d0
      help(1,9) = help(1,9) + (129487.d0*lfh)/54675.d0 - (803.d0*dlxm1
     &     *lfh)/1215.d0 + (11.d0*lfh**2)/540.d0 - (242.d0*lfr)/135.d0 -
     &     (44.d0*lfh*nl)/405.d0 + (44.d0*lfr*nl)/405.d0
      help(1,10) = 3.184134075401232d0 - (1721437.d0*dlxm1)/765450.d0 +
     &     (449.d0*dlxm1**2)/450.d0 - (2882.d0*lth)/3645.d0 + (126631.d0
     &     *nl)/765450.d0 + (88.d0*dlxm1*nl)/1215.d0 - (6241.d0*z2)
     &     /4050.d0
      help(1,10) = help(1,10) + (518783.d0*lfh)/218700.d0 - (7943.d0
     &     *dlxm1*lfh)/12150.d0 + (301.d0*lfh**2)/16200.d0 - (242.d0
     &     *lfr)/135.d0 - (44.d0*lfh*nl)/405.d0 + (44.d0*lfr*nl)/405.d0
      help(1,11) = 2.989731188334473d0 - (67728379.d0*dlxm1)/3.087315d7
     &     +(66274.d0*dlxm1**2)/66825.d0 - (2882.d0*lth)/3645.d0
     &     +(1530533.d0*nl)/8.41995d6 + (88.d0*dlxm1*nl)/1215.d0
     &     -(102574.d0*z2)/66825.d0
      help(1,11) = help(1,11) + (62869771.d0*lfh)/2.64627d7 - (14428.d0
     &     *dlxm1*lfh)/22275.d0 + (1141.d0*lfh**2)/66825.d0 - (242.d0
     &     *lfr)/135.d0 - (44.d0*lfh*nl)/405.d0 + (44.d0*lfr*nl)/405.d0
      help(1,12) = 2.812377392430899d0 - (794441561.d0*dlxm1)/3.704778d8
     &     +(21977.d0*dlxm1**2)/22275.d0 - (2882.d0*lth)/3645.d0
     &     +(66095.d0*nl)/336798.d0 + (88.d0*dlxm1*nl)/1215.d0
     &     -(11359.d0*z2)/7425.d0
      help(1,12) = help(1,12) + (50369699.d0*lfh)/2.117016d7 - (42941.d0
     &     *dlxm1*lfh)/66825.d0 + (469.d0*lfh**2)/29700.d0 - (242.d0
     &     *lfr)/135.d0 - (44.d0*lfh*nl)/405.d0 + (44.d0*lfr*nl)/405.d0
      help(1,13) = 2.649616604881775d0 - (65729396399.d0*dlxm1)
     &     /3.13053741d10 + (56884.d0*dlxm1**2)/57915.d0 - (2882.d0*lth)
     &     /3645.d0 + (693919.d0*nl)/3.31695d6 + (88.d0*dlxm1*nl)
     &     /1215.d0 - (3272.d0*z2)/2145.d0
      help(1,13) = help(1,13) + (7103567387.d0*lfh)/2.9814642d9 -
     &     (110878.d0*dlxm1*lfh)/173745.d0 + (21.d0*lfh**2)/1430.d0 -
     &     (242.d0*lfr)/135.d0 - (44.d0*lfh*nl)/405.d0 + (44.d0*lfr*nl)
     &     /405.d0
      help(1,14) = 2.4994122829852405d0 - (11717780003.d0*dlxm1)
     &     /5.6918862d9 + (1717.d0*dlxm1**2)/1755.d0 - (2882.d0*lth)
     &     /3645.d0 + (8060573.d0*nl)/3.648645d7 + (88.d0*dlxm1*nl)
     &     /1215.d0 - (8011.d0*z2)/5265.d0
      help(1,14) = help(1,14) + (3017560411.d0*lfh)/1.2648636d9 -
     &     (10019.d0*dlxm1*lfh)/15795.d0 + (289.d0*lfh**2)/21060.d0 -
     &     (242.d0*lfr)/135.d0 - (44.d0*lfh*nl)/405.d0 + (44.d0*lfr*nl)
     &     /405.d0
      help(1,15) = 2.3600876986756187d0 - (2875718063.d0*dlxm1)
     &     /1.42297155d9 + (25666.d0*dlxm1**2)/26325.d0 - (2882.d0*lth)
     &     /3645.d0 + (768199.d0*nl)/3.31695d6 + (88.d0*dlxm1*nl)
     &     /1215.d0 - (13322.d0*z2)/8775.d0
      help(1,15) = help(1,15) + (2265933409.d0*lfh)/9.486477d8 -
     &     (49828.d0*dlxm1*lfh)/78975.d0 + (113.d0*lfh**2)/8775.d0 -
     &     (242.d0*lfr)/135.d0 - (44.d0*lfh*nl)/405.d0 + (44.d0*lfr*nl)
     &     /405.d0
      help(1,16) = 2.230259164929097d0 - (869485619.d0*dlxm1)/4.378374d8
     &     +(7873.d0*dlxm1**2)/8100.d0 - (2882.d0*lth)/3645.d0
     &     +(1601419.d0*nl)/6.6339d6 + (88.d0*dlxm1*nl)/1215.d0
     &     -(4091.d0*z2)/2700.d0
      help(1,16) = help(1,16) + (232669051.d0*lfh)/9.72972d7 - (15259.d0
     &     *dlxm1*lfh)/24300.d0 + (131.d0*lfh**2)/10800.d0 - (242.d0
     &     *lfr)/135.d0 - (44.d0*lfh*nl)/405.d0 + (44.d0*lfr*nl)/405.d0

C-}}}
C-{{{ 1/mt^4:

      help(2,0) = 0.d0
      help(2,0) = help(2,0) + 0.d0
      help(2,1) = 0.034016754850088184d0 - (1543.d0*dlxm1)/56700.d0 +
     &     (1543.d0*dlxm1**2)/56700.d0 - (1543.d0*z2)/56700.d0
      help(2,1) = help(2,1) + (1543.d0*lfh)/113400.d0 - (1543.d0*dlxm1
     &     *lfh)/56700.d0 + (1543.d0*lfh**2)/226800.d0
      help(2,2) = 0.1588558201058201d0 - (4541.d0*dlxm1)/113400.d0 +
     &     (1543.d0*dlxm1**2)/113400.d0 - (1543.d0*z2)/113400.d0
      help(2,2) = help(2,2) + (4541.d0*lfh)/226800.d0 - (1543.d0*dlxm1
     &     *lfh)/113400.d0 + (1543.d0*lfh**2)/453600.d0
      help(2,3) = 3.487246514655245d0 - (1657471.d0*dlxm1)/1.0206d6 +
     &     (72983.d0*dlxm1**2)/170100.d0 - (87961.d0*lth)/255150.d0 -
     &     (892.d0*nl)/8505.d0 + (446.d0*dlxm1*nl)/14175.d0 - (113587.d0
     &     *z2)/170100.d0
      help(2,3) = help(2,3) + (245411.d0*lfh)/226800.d0 - (3163.d0*dlxm1
     &     *lfh)/11340.d0 + (1543.d0*lfh**2)/226800.d0 - (2453.d0*lfr)
     &     /3150.d0 - (223.d0*lfh*nl)/4725.d0 + (223.d0*lfr*nl)/4725.d0
      help(2,4) = 3.1201690265841133d0 - (9740987.d0*dlxm1)/6.1236d6 +
     &     (1055417.d0*dlxm1**2)/2.0412d6 - (882923.d0*lth)/1.5309d6 -
     &     (2803.d0*nl)/42525.d0 + (554.d0*dlxm1*nl)/14175.d0 -
     &     (328037.d0*z2)/408240.d0
      help(2,4) = help(2,4) + (578341.d0*lfh)/453600.d0 - (75541.d0
     &     *dlxm1*lfh)/226800.d0 + (1543.d0*lfh**2)/302400.d0 - (3047.d0
     &     *lfr)/3150.d0 - (277.d0*lfh*nl)/4725.d0 + (277.d0*lfr*nl)
     &     /4725.d0
      help(2,5) = 4.072515508781016d0 - (155894251.d0*dlxm1)/7.6545d7 +
     &     (389699.d0*dlxm1**2)/567000.d0 - (61904.d0*lth)/76545.d0 -
     &     (116986.d0*nl)/1.913625d6 + (13459.d0*dlxm1*nl)/255150.d0 -
     &     (608369.d0*z2)/567000.d0
      help(2,5) = help(2,5) + (37830823.d0*lfh)/2.187d7 - (2241391.d0
     &     *dlxm1*lfh)/5.103d6 + (29317.d0*lfh**2)/6.804d6 - (148049.d0
     &     *lfr)/113400.d0 - (13459.d0*lfh*nl)/170100.d0 + (13459.d0*lfr
     &     *nl)/170100.d0
      help(2,6) = 4.893106554878239d0 - (13831451.d0*dlxm1)/5.67d6 +
     &     (8761337.d0*dlxm1**2)/1.0206d7 - (531079.d0*lth)/510300.d0 -
     &     (710473.d0*nl)/1.5309d7 + (8473.d0*dlxm1*nl)/127575.d0 -
     &     (13709617.d0*z2)/1.0206d7
      help(2,6) = help(2,6) + (666158237.d0*lfh)/3.0618d8 - (5575477.d0
     &     *dlxm1*lfh)/1.0206d7 + (16973.d0*lfh**2)/4.536d6 - (93203.d0
     &     *lfr)/56700.d0 - (8473.d0*lfh*nl)/85050.d0 + (8473.d0*lfr*nl)
     &     /85050.d0
      help(2,7) = 5.665644048631714d0 - (391529213.d0*dlxm1)/1.38915d8 +
     &     (18398419.d0*dlxm1**2)/1.78605d7 - (139171.d0*lth)/109350.d0
     &     - (299933.d0*nl)/1.1907d7 + (973.d0*dlxm1*nl)/12150.d0 -
     &     (14414647.d0*z2)/8.93025d6
      help(2,7) = help(2,7) + (6551165407.d0*lfh)/2.50047d9 -
     &     (3892853.d0*dlxm1*lfh)/5.9535d6 + (26231.d0*lfh**2)/7.938d6 -
     &     (10703.d0*lfr)/5400.d0 - (973.d0*lfh*nl)/8100.d0 + (973.d0
     &     *lfr*nl)/8100.d0
      help(2,8) = 6.405512591404245d0 - (1413212459.d0*dlxm1)/4.44528d8
     &     +(11451127.d0*dlxm1**2)/9.5256d6 - (2303551.d0*lth)/1.5309d6
     &     +(9689.d0*nl)/7.938d6 + (2392.d0*dlxm1*nl)/25515.d0
     &     -(5986333.d0*z2)/3.1752d6
      help(2,8) = help(2,8) + (24513581731.d0*lfh)/8.001504d9 -
     &     (21770237.d0*dlxm1*lfh)/2.85768d7 + (112639.d0*lfh**2)
     &     /3.81024d7 - (6578.d0*lfr)/2835.d0 - (1196.d0*lfh*nl)/8505.d0
     &     + (1196.d0*lfr*nl)/8505.d0
      help(2,9) = 7.119047764661889d0 - (63448335239.d0*dlxm1)
     &     /1.8003384d10 + (19638349.d0*dlxm1**2)/1.42884d7 - (73853.d0
     &     *lth)/42525.d0 + (1959151.d0*nl)/6.1236d7 + (27407.d0*dlxm1
     &     *nl)/255150.d0 - (6163453.d0*z2)/2.85768d6
      help(2,9) = help(2,9) + (126272995991.d0*lfh)/3.6006768d10 -
     &     (12431093.d0*dlxm1*lfh)/1.42884d7 + (16973.d0*lfh**2)
     &     /6.3504d6 - (301477.d0*lfr)/113400.d0 - (27407.d0*lfh*nl)
     &     /170100.d0 + (27407.d0*lfr*nl)/170100.d0
      help(2,10) = 7.809976319735578d0 - (19833654703.d0*dlxm1)
     &     /5.143824d9+ (31575407.d0*dlxm1**2)/2.0412d7 - (602773.d0
     &     *lth)/306180.d0+ (2851579.d0*nl)/4.28652d7 + (5149.d0*dlxm1
     &     *nl)/42525.d0 -(49569727.d0*z2)/2.0412d7
      help(2,10) = help(2,10) + (4515120887.d0*lfh)/1.143072d9 -
     &     (2219023.d0*dlxm1*lfh)/2.268d6 + (66349.d0*lfh**2)/2.7216d7 -
     &     (56639.d0*lfr)/18900.d0 - (5149.d0*lfh*nl)/28350.d0 +
     &     (5149.d0*lfr*nl)/28350.d0
      help(2,11) = 8.480888934166705d0 - (92812796059.d0*dlxm1)
     &     /2.2228668d10 + (48261229.d0*dlxm1**2)/2.80665d7 -
     &     (1684511.d0*lth)/765450.d0 + (42172649.d0*nl)/4.041576d8 +
     &     (34381.d0*dlxm1*nl)/255150.d0 - (18946756.d0*z2)/7.016625d6
      help(2,11) = help(2,11) + (455689207223.d0*lfh)/1.03733784d11 -
     &     (30506789.d0*dlxm1*lfh)/2.80665d7 + (251509.d0*lfh**2)
     &     /1.12266d8 - (378191.d0*lfr)/113400.d0 - (34381.d0*lfh*nl)
     &     /170100.d0 + (34381.d0*lfr*nl)/170100.d0
      help(2,12) = 9.13374911539071d0 - (2790904741913.d0*dlxm1)
     &     /6.22402704d11 + (212438209.d0*dlxm1**2)/1.12266d8 -
     &     (1241393.d0*lth)/510300.d0 + (513095921.d0*nl)/3.536379d9 +
     &     (18934.d0*dlxm1*nl)/127575.d0 - (333675809.d0*z2)/1.12266d8
      help(2,12) = help(2,12) + (6019394658169.d0*lfh)/1.244805408d12 -
     &     (134225789.d0*dlxm1*lfh)/1.12266d8 + (103381.d0*lfh**2)
     &     /4.9896d7 - (104137.d0*lfr)/28350.d0 - (9467.d0*lfh*nl)
     &     /42525.d0 + (9467.d0*lfr*nl)/42525.d0
      help(2,13) = 9.770122060234193d0 - (1711223635009.d0*dlxm1)
     &     /3.57775704d11 + (301394531.d0*dlxm1**2)/1.459458d8 -
     &     (1019834.d0*lth)/382725.d0 + (9507583.d0*nl)/5.04504d7 +
     &     (919.d0*dlxm1*nl)/5670.d0 - (473478157.d0*z2)/1.459458d8
      help(2,13) = help(2,13) + (6854276136563.d0*lfh)/1.298593296d12 -
     &     (21151703.d0*dlxm1*lfh)/1.62162d7 + (1543.d0*lfh**2)
     &     /800800.d0 - (10109.d0*lfr)/2520.d0 - (919.d0*lfh*nl)/3780.d0
     &     + (919.d0*lfr*nl)/3780.d0
      help(2,14) = 10.391297003281323d0 - (48507874573999.d0*dlxm1)
     &     /9.562368816d12 + (46190153.d0*dlxm1**2)/2.06388d7 -
     &     (633499.d0*lth)/218700.d0 + (1025361131.d0*nl)/4.378374d9 +
     &     (3203.d0*dlxm1*nl)/18225.d0 - (4838143.d0*z2)/1.37592d6
      help(2,14) = help(2,14) + (36469299977477.d0*lfh)/6.374912544d12 -
     &     (262497589.d0*dlxm1*lfh)/1.857492d8 + (445927.d0*lfh**2)
     &     /2.476656d8 - (35233.d0*lfr)/8100.d0 - (3203.d0*lfh*nl)
     &     /12150.d0 + (3203.d0*lfr*nl)/12150.d0
      help(2,15) = 10.998360664474797d0 - (12799915495001.d0*dlxm1)
     &     /2.390592204d12 + (559801451.d0*dlxm1**2)/2.321865d8 -
     &     (31931.d0*lth)/10206.d0 + (17290869839.d0*nl)/6.1297236d10 +
     &     (48329.d0*dlxm1*nl)/255150.d0 - (439813433.d0*z2)/1.1609325d8
      help(2,15) = help(2,15) + (9822449812027.d0*lfh)/1.593728136d12 -
     &     (353404351.d0*dlxm1*lfh)/2.321865d8 + (174359.d0*lfh**2)
     &     /1.03194d8 - (531619.d0*lfr)/113400.d0 - (48329.d0*lfh*nl)
     &     /170100.d0 + (48329.d0*lfr*nl)/170100.d0
      help(2,16) = 11.592245026035185d0 - (2759865537719.d0*dlxm1)
     &     /4.90377888d11 + (738431437.d0*dlxm1**2)/2.85768d8 -
     &     (5144807.d0*lth)/1.5309d6 + (6782755841.d0*nl)/2.0432412d10 +
     &     (8636.d0*dlxm1*nl)/42525.d0 - (1160404877.d0*z2)/2.85768d8
      help(2,16) = help(2,16) + (2159478952957.d0*lfh)/3.26918592d11 -
     &     (155363519.d0*dlxm1*lfh)/9.5256d7 + (202133.d0*lfh**2)
     &     /1.27008d8 - (23749.d0*lfr)/4725.d0 - (4318.d0*lfh*nl)
     &     /14175.d0 + (4318.d0*lfr*nl)/14175.d0

C-}}}
C-{{{ 1/mt^6:

      help(3,0) = 0.d0
      help(3,0) = help(3,0) + (0.d0)
      help(3,1) = 0.0049823633156966494d0 - 0.0039858906525573196d0
     &     *dlxm1 + 0.0039858906525573196d0*dlxm1**2 -
     &     0.0039858906525573196d0*z2
      help(3,1) = help(3,1) + (0.0019929453262786598d0*lfh -
     &     0.0039858906525573196d0*dlxm1*lfh + 0.0009964726631393299d0
     &     *lfh**2)
      help(3,2) = 0.032146384479717814d0 - 0.006172839506172839d0*dlxm1
     &     + 0.0019929453262786598d0*dlxm1**2 - 0.0019929453262786598d0
     &     *z2
      help(3,2) = help(3,2) + (0.0030864197530864196d0*lfh -
     &     0.0019929453262786598d0*dlxm1*lfh + 0.0004982363315696649d0
     &     *lfh**2)
      help(3,3) = 0.8766015194921133d0 - 0.3919533607681756d0*dlxm1 +
     &     0.10693709582598472d0*dlxm1**2 - 0.11365314520870076d0*lth -
     &     0.02696453066823437d0*nl + 0.008089359200470311d0*dlxm1*nl -
     &     0.16685479129923575d0*z2
      help(3,3) = help(3,3) + (0.2747668038408779d0*lfh -
     &     0.06870076425631981d0*dlxm1*lfh + 0.0009964726631393299d0*lfh
     &     **2 - 0.2002116402116402d0*lfr - 0.012134038800705467d0*lfh
     &     *nl + 0.012134038800705467d0*lfr*nl)
      help(3,4) = 1.344348784639599d0 - 0.6323043961068653d0*dlxm1 +
     &     0.19621889084852048d0*dlxm1**2 - 0.2670737474688092d0*lth -
     &     0.034144620811287475d0*nl + 0.015238095238095238d0*dlxm1*nl -
     &     0.3062796394277876d0*z2
      help(3,4) = help(3,4) + (0.51d0*lfh - 0.12489417989417989d0*dlxm1
     &     *lfh + 0.0007473544973544973d0*lfh**2 - 0.37714285714285717d0
     &     *lfr - 0.022857142857142857d0*lfh*nl + 0.022857142857142857d0
     &     *lfr*nl)
      help(3,5) = 2.2038393332742334d0 - 1.0357776210072507d0*dlxm1 +
     &     0.3315896531452087d0*dlxm1**2 - 0.47697307466196354d0*lth -
     &     0.04602312365275328d0*nl + 0.025961199294532628d0*dlxm1*nl -
     &     0.518538506760729d0*z2
      help(3,5) = help(3,5) + (0.878831941994905d0*lfh -
     &     0.21021399176954733d0*dlxm1*lfh + 0.0006310993533215755d0*lfh
     &     **2 - 0.6425396825396825d0*lfr - 0.038941798941798944d0*lfh
     &     *nl + 0.038941798941798944d0*lfr*nl)
      help(3,6) = 3.2259024643844736d0 - 1.520021033379058d0*dlxm1 +
     &     0.5011359984322947d0*dlxm1**2 - 0.7433511267881638d0*lth -
     &     0.05427892089620485d0*nl + 0.03937291789143641d0*dlxm1*nl -
     &     0.7841891044483638d0*z2
      help(3,6) = help(3,6) + (1.341701626494219d0*lfh -
     &     0.31717558299039783d0*dlxm1*lfh + 0.0005480599647266314d0*lfh
     &     **2 - 0.9744797178130511d0*lfr - 0.05905937683715461d0*lfh*nl
     &     + 0.05905937683715461d0*lfr*nl)
      help(3,7) = 4.413410960650191d0 - 2.0833301995224898d0*dlxm1 +
     &     0.704800985414742d0*dlxm1**2 - 1.06620790384741d0*lth -
     &     0.05797754822093446d0*nl + 0.05547325102880658d0*dlxm1*nl -
     &     1.1031744911956551d0*z2
      help(3,7) = help(3,7) + (1.8997321079637028d0*lfh -
     &     0.4457220122616948d0*dlxm1*lfh + 0.00048400100781053164d0*lfh
     &     **2 - 1.372962962962963d0*lfr - 0.08320987654320988d0*lfh*nl
     &     + 0.08320987654320988d0*lfr*nl)
      help(3,8) = 5.76087300418672d0 - 2.722720215099561d0*dlxm1 +
     &     0.9425608885529521d0*dlxm1**2 - 1.445543405839702d0*lth -
     &     0.05614610453234792d0*nl + 0.07426219870664315d0*dlxm1*nl -
     &     1.475470941463005d0*z2
      help(3,9) = 7.26264998783108d0 - 3.4354105587038526d0*dlxm1 +
     &     1.2144014725231655d0*dlxm1**2 - 1.88135763276504d0*lth -
     &     0.047929842078578117d0*nl + 0.09573976092494611d0*dlxm1*nl -
     &     1.9010642199266539d0*z2
      help(3,9) = help(3,9) + (3.301884221710763d0*lfh -
     &     0.7674839730130736d0*dlxm1*lfh + 0.00039147140337616527d0*lfh
     &     **2 - 2.3695590828924162d0*lfr - 0.14360964138741916d0*lfh*nl
     &     + 0.14360964138741916d0*lfr*nl)
      help(3,10) = 8.913606585949958d0 - 4.218903107804621d0*dlxm1 +
     &     1.5203132471095433d0*dlxm1**2 - 2.373650584623424d0*lth -
     &     0.032579290426733104d0*nl + 0.11990593768371546d0*dlxm1*nl -
     &     2.3799448363707625d0*z2
      help(3,10) = help(3,10) + (4.1460937388604275d0*lfh -
     &     0.9606757789535567d0*dlxm1*lfh + 0.00035706937095825983d0*lfh
     &     **2 - 2.9676719576719575d0*lfr - 0.17985890652557318d0*lfh*nl
     &     + 0.17985890652557318d0*lfr*nl)
      help(3,11) = 10.709126732730919d0 - 5.07094817732797d0*dlxm1 +
     &     1.8602895979192275d0*dlxm1**2 - 2.922422261414854d0*lth -
     &     0.009430889477626691d0*nl + 0.1467607289829512d0*dlxm1*nl -
     &     2.9121061764024727d0*z2
      help(3,11) = help(3,11) + (5.085751443042574d0*lfh -
     &     1.1753983574724316d0*dlxm1*lfh + 0.0003281314022054763d0*lfh
     &     **2 - 3.632328042328042d0*lfr - 0.2201410934744268d0*lfh*nl +
     &     0.2201410934744268d0*lfr*nl)
      help(3,12) = 12.645046789319782d0 - 5.989504376509907d0*dlxm1 +
     &     2.234325779844298d0*dlxm1**2 - 3.5276726631393296d0*lth +
     &     0.022108679527844725d0*nl + 0.17630413482265334d0*dlxm1*nl -
     &     3.4975434949138653d0*z2
      help(3,12) = help(3,12) + (6.120868159817956d0*lfh -
     &     1.4116469634617783d0*dlxm1*lfh + 0.0003034712201378868d0*lfh
     &     **2 - 4.36352733686067d0*lfr - 0.26445620223398003d0*lfh*nl +
     &     0.26445620223398003d0*lfr*nl)
      help(3,13) = 14.717585968266988d0 - 6.972704931012262d0*dlxm1 +
     &     2.642418308714605d0*dlxm1**2 - 4.189401789796851d0*lth +
     &     0.06257457651108445d0*nl + 0.20853615520282187d0*dlxm1*nl -
     &     4.13625330773479d0*z2
      help(3,13) = help(3,13) + (7.251451521065504d0*lfh -
     &     1.669418112751446d0*dlxm1*lfh + 0.0002822177822177822d0*lfh
     &     **2 - 5.161269841269841d0*lfr - 0.3128042328042328d0*lfh*nl +
     &     0.3128042328042328d0*lfr*nl)
      help(3,14) = 16.923287121563614d0 - 8.01883082382565d0*dlxm1 +
     &     3.0845645741677488d0*dlxm1**2 - 4.9076096413874195d0*lth +
     &     0.11245317909603623d0*nl + 0.24345679012345678d0*dlxm1*nl -
     &     4.828233004502846d0*z2
      help(3,14) = help(3,14) + (8.477507153667707d0*lfh -
     &     1.9487091949790363d0*dlxm1*lfh + 0.000263718497845482d0*lfh
     &     **2 - 6.025555555555556d0*lfr - 0.36518518518518517d0*lfh*nl
     &     + 0.36518518518518517d0*lfr*nl)
      help(3,15) = 19.258968489541967d0 - 9.126289431117211d0*dlxm1 +
     &     3.560762585249358d0*dlxm1**2 - 5.682296217911032d0*lth +
     &     0.17218946665066595d0*nl + 0.2810660395845581d0*dlxm1*nl -
     &     5.573480594263663d0*z2
      help(3,15) = help(3,15) + (9.79903933697786d0*lfh -
     &     2.249518219190177d0*dlxm1*lfh + 0.0002474756284280094d0*lfh
     &     **2 - 6.956384479717813d0*lfr - 0.42159905937683717d0*lfh*nl
     &     + 0.42159905937683717d0*lfr*nl)
      help(3,16) = 21.721684663561085d0 - 10.293597373836725d0*dlxm1 +
     &     4.071010798969794d0*dlxm1**2 - 6.513461519367692d0*lth +
     &     0.24219292201038234d0*nl + 0.3213639035861258d0*dlxm1*nl -
     &     6.3719945340276025d0*z2
      help(3,16) = help(3,16) + (11.216051401556262d0*lfh -
     &     2.57184364239523d0*dlxm1*lfh + 0.00023310342655580752d0*lfh
     &     **2 -7.953756613756614d0*lfr - 0.4820458553791887d0*lfh*nl
     &     +0.4820458553791887d0*lfr*nl)

C-}}}

      do k=0,nsoftmt(2,3)
         sum = 0.d0
         do j=2,nmtlim(2,3),2
            sum = sum + (mh/mt)**j * help(j/2,k)
         enddo
         helpmt(k) = sum
      enddo

C$$$      modified = 1
      sum = 0.d0
c..   this is  G(x) = sigma/xt^ncat2 :
      do k=0,nsoftmt(2,3)
         sum = 0.d0
         do i=0,k
            sum = sum + bininv(ncat2,i) * helpmt(k-i)
         enddo
         helpx(k) = sum
      enddo

      sqqb2mtexp = 0.d0
      do k=0,nsoftmt(2,3)
         sqqb2mtexp = sqqb2mtexp + xm1**k * helpx(k)
      enddo

      sqqb2mtexp = xt**ncat2 * sqqb2mtexp

      return
      end

C-}}}
C-{{{ function sqq2mtexp(xt)

      real*8 function sqq2mtexp(xt)
C
C
      implicit none
      integer i,j,k
      real*8 sum,xt,xm1,dlxm1,yy,rpow2,bininv,nl,dlm1os
      real*8 help(10,0:20),helpmt(0:20),helpx(0:20)
      include '../commons/common-errors.f'
      include '../commons/common-expand.f'
      include '../commons/common-keys.f'
      include '../commons/common-consts.f'
      include '../commons/common-vars.f'

      if (lpseudo) stop 'sqq2mtexp'
      if (nmtlim(2,4).gt.6) stop 'sqq2mtexp'
      if ((nmtlim(2,4).eq.6).and.(nsoftmt(2,4).gt.13)) stop 'sqq2mtexp'

      do i=0,20
         do j=1,10
            help(j,i) = 0.d0
         enddo
      enddo

      xm1 = 1.d0-xt
      dlxm1 = dlog(xm1)
 
      nl=nf
      dlm1os = - lth

C-{{{ 1/mt^2:

      help(1,0) = 0
      help(1,0) = help(1,0) + 0
      help(1,1) = 0.25925925925925924d0 - (28.d0*dlxm1)/135.d0 + (28.d0
     &     *dlxm1**2)/135.d0 - (28.d0*z2)/135.d0
      help(1,1) = help(1,1) + (14.d0*lfh)/135.d0 - (28.d0*dlxm1*lfh)
     &     /135.d0 + (7*lfh**2)/135.d0
      help(1,2) = 0.43950617283950616d0 - (4*dlxm1)/15.d0 + (14.d0*dlxm1
     &     **2)/135.d0 - (14.d0*z2)/135.d0
      help(1,2) = help(1,2) + (2*lfh)/15.d0 - (14.d0*dlxm1*lfh)/135.d0 +
     &     (7*lfh**2)/270.d0
      help(1,3) = 0.5888888888888889d0 - (40.d0*dlxm1)/81.d0 + (28.d0
     &     *dlxm1**2)/135.d0 - (28.d0*z2)/135.d0
      help(1,3) = help(1,3) + (20.d0*lfh)/81.d0 - (28.d0*dlxm1*lfh)
     &     /135.d0 + (7*lfh**2)/135.d0
      help(1,4) = 0.4102366255144033d0 - (97.d0*dlxm1)/270.d0 + (7*dlxm1
     &     **2)/45.d0 - (7*z2)/45.d0
      help(1,4) = help(1,4) + (97.d0*lfh)/540.d0 - (7*dlxm1*lfh)/45.d0 +
     &     (7*lfh**2)/180.d0
      help(1,5) = 0.3446663923182442d0 - (10616.d0*dlxm1)/30375.d0 +
     &     (266.d0*dlxm1**2)/2025.d0 - (266.d0*z2)/2025.d0
      help(1,5) = help(1,5) + (5308.d0*lfh)/30375.d0 - (266.d0*dlxm1
     &     *lfh)/2025.d0 + (133.d0*lfh**2)/4050.d0
      help(1,6) = 0.2780417924096936d0 - (10681.d0*dlxm1)/30375.d0 +
     &     (77.d0*dlxm1**2)/675.d0 - (77.d0*z2)/675.d0
      help(1,6) = help(1,6) + (10681.d0*lfh)/60750.d0 - (77.d0*dlxm1
     &     *lfh)/675.d0 + (77.d0*lfh**2)/2700.d0
      help(1,7) = 0.21487180650037793d0 - (76063.d0*dlxm1)/212625.d0 +
     &     (68.d0*dlxm1**2)/675.d0 - (68.d0*z2)/675.d0
      help(1,7) = help(1,7) + (76063.d0*lfh)/425250.d0 - (68.d0*dlxm1
     &     *lfh)/675.d0 + (17.d0*lfh**2)/675.d0
      help(1,8) = 0.15655436869535194d0 - (62159.d0*dlxm1)/170100.d0 +
     &     (73.d0*dlxm1**2)/810.d0 - (73.d0*z2)/810.d0
      help(1,8) = help(1,8) + (62159.d0*lfh)/340200.d0 - (73.d0*dlxm1
     &     *lfh)/810.d0 + (73.d0*lfh**2)/3240.d0
      help(1,9) = 0.10311158546637676d0 - (47666.d0*dlxm1)/127575.d0 +
     &     (11.d0*dlxm1**2)/135.d0 - (11.d0*z2)/135.d0
      help(1,9) = help(1,9) + (23833.d0*lfh)/127575.d0 - (11.d0*dlxm1
     &     *lfh)/135.d0 + (11.d0*lfh**2)/540.d0
      help(1,10) = 0.05415854045550548d0 - (4639.d0*dlxm1)/12150.d0 +
     &     (301.d0*dlxm1**2)/4050.d0 - (301.d0*z2)/4050.d0
      help(1,10) = help(1,10) + (4639.d0*lfh)/24300.d0 - (301.d0*dlxm1
     &     *lfh)/4050.d0 + (301.d0*lfh**2)/16200.d0
      help(1,11) = 0.009218939945097707d0 - (5156291.d0*dlxm1)
     &     /1.323135d7+ (4564.d0*dlxm1**2)/66825.d0 - (4564.d0*z2)
     &     /66825.d0
      help(1,11) = help(1,11) + (5156291.d0*lfh)/2.64627d7 - (4564.d0
     &     *dlxm1*lfh)/66825.d0 + (1141.d0*lfh**2)/66825.d0
      help(1,12) = -0.03217062074054345d0 - (2335703.d0*dlxm1)/5.8806d6
     &     +(469.d0*dlxm1**2)/7425.d0 - (469.d0*z2)/7425.d0
      help(1,12) = help(1,12) + (2335703.d0*lfh)/1.17612d7 - (469.d0
     &     *dlxm1*lfh)/7425.d0 + (469.d0*lfh**2)/29700.d0
      help(1,13) = -0.07042810703418845d0 - (66954259.d0*dlxm1)
     &     /1.656369d8+ (42.d0*dlxm1**2)/715.d0 - (42.d0*z2)/715.d0
      help(1,13) = help(1,13) + (66954259.d0*lfh)/3.312738d8 - (42.d0
     &     *dlxm1*lfh)/715.d0 + (21.d0*lfh**2)/1430.d0
      help(1,14) = -0.10591930396107817d0 - (779416753.d0*dlxm1)
     &     /1.8972954d9 + (289.d0*dlxm1**2)/5265.d0 - (289.d0*z2)
     &     /5265.d0
      help(1,14) = help(1,14) + (779416753.d0*lfh)/3.7945908d9 - (289.d0
     &     *dlxm1*lfh)/5265.d0 + (289.d0*lfh**2)/21060.d0
      help(1,15) = -0.13896038595312218d0 - (21974209.d0*dlxm1)
     &     /5.270265d7+ (452.d0*dlxm1**2)/8775.d0 - (452.d0*z2)/8775.d0
      help(1,15) = help(1,15) + (21974209.d0*lfh)/1.054053d8 - (452.d0
     &     *dlxm1*lfh)/8775.d0 + (113.d0*lfh**2)/8775.d0
      help(1,16) = -0.16982348536780487d0 - (2284739.d0*dlxm1)/5.4054d6
     &     +(131.d0*dlxm1**2)/2700.d0 - (131.d0*z2)/2700.d0
      help(1,16) = help(1,16) + (2284739.d0*lfh)/1.08108d7 - (131.d0
     &     *dlxm1*lfh)/2700.d0 + (131.d0*lfh**2)/10800.d0

C-}}}
C-{{{ 1/mt^4:

      help(2,0) = 0.d0
      help(2,0) = help(2,0) + 0.d0    
      help(2,1) = 0.034016754850088184d0 - (1543.d0*dlxm1)/56700.d0 +
     &     (1543.d0*dlxm1**2)/56700.d0 - (1543.d0*z2)/56700.d0
      help(2,1) = help(2,1) +       (1543.d0*lfh)/113400.d0 - (1543.d0
     &     *dlxm1*lfh)/56700.d0 + (1543.d0*lfh**2)/226800.d0
      help(2,2) = 0.06272192827748384d0 - (4541.d0*dlxm1)/113400.d0 +
     &     (1543.d0*dlxm1**2)/113400.d0 - (1543.d0*z2)/113400.d0
      help(2,2) = help(2,2) +       (4541.d0*lfh)/226800.d0 - (1543.d0
     &     *dlxm1*lfh)/113400.d0 + (1543.d0*lfh**2)/453600.d0
      help(2,3) = 0.07143371546149324d0 - (20849.d0*dlxm1)/340200.d0 +
     &     (1543.d0*dlxm1**2)/56700.d0 - (1543.d0*z2)/56700.d0
      help(2,3) = help(2,3) +       (20849.d0*lfh)/680400.d0 - (1543.d0
     &     *dlxm1*lfh)/56700.d0 + (1543.d0*lfh**2)/226800.d0
      help(2,4) = 0.04131335121497159d0 - (3241.d0*dlxm1)/97200.d0 +
     &     (1543.d0*dlxm1**2)/75600.d0 - (1543.d0*z2)/75600.d0
      help(2,4) = help(2,4) +       (3241.d0*lfh)/194400.d0 - (1543.d0
     &     *dlxm1*lfh)/75600.d0 + (1543.d0*lfh**2)/302400.d0
      help(2,5) = 0.026245303579593704d0 - (451417.d0*dlxm1)/2.5515d7 +
     &     (29317.d0*dlxm1**2)/1.701d6 - (29317.d0*z2)/1.701d6
      help(2,5) = help(2,5) +       (451417.d0*lfh)/5.103d7 - (29317.d0
     &     *dlxm1*lfh)/1.701d6 + (29317.d0*lfh**2)/6.804d6
      help(2,6) = 0.014878492117926275d0 - (11777.d0*dlxm1)/7.29d6 +
     &     (16973.d0*dlxm1**2)/1.134d6 - (16973.d0*z2)/1.134d6
      help(2,6) = help(2,6) +       (11777.d0*lfh)/1.458d7 - (16973.d0
     &     *dlxm1*lfh)/1.134d6 + (16973.d0*lfh**2)/4.536d6
      help(2,7) = 0.00801048300871817d0 + (6310541.d0*dlxm1)/4.16745d8 +
     &     (26231.d0*dlxm1**2)/1.9845d6 - (26231.d0*z2)/1.9845d6
      help(2,7) = help(2,7) +       (-6310541.d0*lfh)/8.3349d8 -
     &     (26231.d0*dlxm1*lfh)/1.9845d6 +(26231.d0*lfh**2)/7.938d6
      help(2,8) = 0.00550701035313496d0 + (129925661.d0*dlxm1)
     &     /4.000752d9+ (112639.d0*dlxm1**2)/9.5256d6 - (112639.d0*z2)
     &     /9.5256d6
      help(2,8) = help(2,8) +       (-129925661.d0*lfh)/8.001504d9 -
     &     (112639.d0*dlxm1*lfh)/9.5256d6 +(112639.d0*lfh**2)/3.81024d7
      help(2,9) = 0.0069507152040998305d0 + (301746323.d0*dlxm1)
     &     /6.001128d9 + (16973.d0*dlxm1**2)/1.5876d6 - (16973.d0*z2)
     &     /1.5876d6
      help(2,9) = help(2,9) +       (-301746323.d0*lfh)/1.2002256d10 -
     &     (16973.d0*dlxm1*lfh)/1.5876d6 +(16973.d0*lfh**2)/6.3504d6
      help(2,10) = 0.011888766011503727d0 + (117414811.d0*dlxm1)
     &     /1.714608d9 + (66349.d0*dlxm1**2)/6.804d6 - (66349.d0*z2)
     &     /6.804d6
      help(2,10) = help(2,10) +       (-117414811.d0*lfh)/3.429216d9 -
     &     (66349.d0*dlxm1*lfh)/6.804d6 +(66349.d0*lfh**2)/2.7216d7
      help(2,11) = 0.019906093992045244d0 + (2707508423.d0*dlxm1)
     &     /3.11201352d10 + (251509.d0*dlxm1**2)/2.80665d7 - (251509.d0
     &     *z2)/2.80665d7
      help(2,11) = help(2,11) +       (-2707508423.d0*lfh)/6.22402704d10
     &     - (251509.d0*dlxm1*lfh)/2.80665d7 + (251509.d0*lfh**2)
     &     /1.12266d8
      help(2,12) = 0.030642203768125452d0 + (7316464783.d0*dlxm1)
     &     /6.9155856d10 + (103381.d0*dlxm1**2)/1.2474d7 - (103381.d0
     &     *z2)/1.2474d7
      help(2,12) = help(2,12) +       (-7316464783.d0*lfh)/1.38311712d11
     &     - (103381.d0*dlxm1*lfh)/1.2474d7 + (103381.d0*lfh**2)
     &     /4.9896d7
      help(2,13) = 0.04378988322467535d0 + (243137843383.d0*dlxm1)
     &     /1.947889944d12 + (1543.d0*dlxm1**2)/200200.d0 - (1543.d0*z2)
     &     /200200.d0
      help(2,13) = help(2,13) +       (-243137843383.d0*lfh)
     &     /3.895779888d12 - (1543.d0*dlxm1*lfh)/200200.d0 + (1543.d0
     &     *lfh**2)/800800.d0
      help(2,14) = 0.059088683232576815d0 + (459122329403.d0*dlxm1)
     &     /3.187456272d12 + (445927.d0*dlxm1**2)/6.19164d7 - (445927.d0
     &     *z2)/6.19164d7
      help(2,14) = help(2,14) +       (-459122329403.d0*lfh)
     &     /6.374912544d12 - (445927.d0*dlxm1*lfh)/6.19164d7 +
     &     (445927.d0*lfh**2)/2.476656d8
      help(2,15) = 0.07631758717731546d0 + (43409476207.d0*dlxm1)
     &     /2.65621356d11 + (174359.d0*dlxm1**2)/2.57985d7 - (174359.d0
     &     *z2)/2.57985d7
      help(2,15) = help(2,15) + (-43409476207.d0*lfh)/5.31242712d11 -
     &     (174359.d0*dlxm1*lfh)/2.57985d7 + (174359.d0*lfh**2)
     &     /1.03194d8
      help(2,16) = 0.09528831781942194d0 + (4272250597.d0*dlxm1)
     &     /2.3351328d10 + (202133.d0*dlxm1**2)/3.1752d7 - (202133.d0
     &     *z2)/3.1752d7
      help(2,16) = help(2,16) + (-4272250597.d0*lfh)/4.6702656d10 -
     &     (202133.d0*dlxm1*lfh)/3.1752d7+ (202133.d0*lfh**2)/1.27008d8

C-}}}
C-{{{ 1/mt^6:

      help(3,0) = 0.d0
      help(3,0) = help(3,0) + (0.d0)
      help(3,1) = 0.0049823633156966494d0 - 0.0039858906525573196d0
     &     *dlxm1 + 0.0039858906525573196d0*dlxm1**2 -
     &     0.0039858906525573196d0*z2
      help(3,1) = help(3,1) + (0.0019929453262786598d0*lfh -
     &     0.0039858906525573196d0*dlxm1*lfh + 0.0009964726631393299d0
     &     *lfh**2)
      help(3,2) = 0.009494415049970605d0 - 0.006172839506172839d0*dlxm1
     &     + 0.0019929453262786598d0*dlxm1**2 - 0.0019929453262786598d0
     &     *z2
      help(3,2) = help(3,2) + (0.0030864197530864196d0*lfh -
     &     0.0019929453262786598d0*dlxm1*lfh + 0.0004982363315696649d0
     &     *lfh**2)
      help(3,3) = 0.010332647462277092d0 - 0.008894767783656672d0*dlxm1
     &     + 0.0039858906525573196d0*dlxm1**2 - 0.0039858906525573196d0
     &     *z2
      help(3,3) = help(3,3) + (0.004447383891828336d0*lfh -
     &     0.0039858906525573196d0*dlxm1*lfh + 0.0009964726631393299d0
     &     *lfh**2)
      help(3,4) = 0.007043834509112287d0 - 0.005349794238683128d0*dlxm1
     &     + 0.0029894179894179892d0*dlxm1**2 - 0.0029894179894179892d0
     &     *z2
      help(3,4) = help(3,4) + (0.002674897119341564d0*lfh -
     &     0.0029894179894179892d0*dlxm1*lfh + 0.0007473544973544973d0
     &     *lfh**2)
      help(3,5) = 0.006820909595662682d0 - 0.004605682931608858d0*dlxm1
     &     + 0.002524397413286302d0*dlxm1**2 - 0.002524397413286302d0*z2
      help(3,5) = help(3,5) + (0.002302841465804429d0*lfh -
     &     0.002524397413286302d0*dlxm1*lfh + 0.0006310993533215755d0
     &     *lfh**2)
      help(3,6) = 0.007821030983952794d0 - 0.005109700176366843d0*dlxm1
     &     + 0.0021922398589065257d0*dlxm1**2 - 0.0021922398589065257d0
     &     *z2
      help(3,6) = help(3,6) + (0.0025548500881834215d0*lfh -
     &     0.0021922398589065257d0*dlxm1*lfh + 0.0005480599647266314d0
     &     *lfh**2)
      help(3,7) = 0.009695571201185606d0 - 0.006950792451019208d0*dlxm1
     &     + 0.0019360040312421266d0*dlxm1**2 - 0.0019360040312421266d0
     &     *z2
      help(3,7) = help(3,7) + (0.003475396225509604d0*lfh -
     &     0.0019360040312421266d0*dlxm1*lfh + 0.00048400100781053164d0
     &     *lfh**2)
      help(3,8) = 0.011986510267716495d0 - 0.010211270781093155d0*dlxm1
     &     + 0.0017319643906945495d0*dlxm1**2 - 0.0017319643906945495d0
     &     *z2
      help(3,8) = help(3,8) + (0.005105635390546578d0*lfh -
     &     0.0017319643906945495d0*dlxm1*lfh + 0.0004329910976736374d0
     &     *lfh**2)
      help(3,9) = 0.014255264490302278d0 - 0.014944813375085485d0*dlxm1
     &     + 0.001565885613504661d0*dlxm1**2 - 0.001565885613504661d0*z2
      help(3,9) = help(3,9) + (0.007472406687542742d0*lfh -
     &     0.001565885613504661d0*dlxm1*lfh + 0.00039147140337616527d0
     &     *lfh**2)
      help(3,10) = 0.016117296670124164d0 - 0.021187561705066114d0*dlxm1
     &     + 0.0014282774838330393d0*dlxm1**2 - 0.0014282774838330393d0
     &     *z2
      help(3,10) = help(3,10) + (0.010593780852533057d0*lfh -
     &     0.0014282774838330393d0*dlxm1*lfh + 0.00035706937095825983d0
     &     *lfh**2)
      help(3,11) = 0.01724375654368348d0 - 0.028964913769397763d0*dlxm1
     &     + 0.0013125256088219051d0*dlxm1**2 - 0.0013125256088219051d0
     &     *z2
      help(3,11) = help(3,11) + (0.014482456884698881d0*lfh -
     &     0.0013125256088219051d0*dlxm1*lfh + 0.0003281314022054763d0
     &     *lfh**2)
      help(3,12) = 0.017354560715621227d0 - 0.03829533324842368d0*dlxm1
     &     + 0.0012138848805515472d0*dlxm1**2 - 0.0012138848805515472d0
     &     *z2
      help(3,12) = help(3,12) + (0.01914766662421184d0*lfh -
     &     0.0012138848805515472d0*dlxm1*lfh + 0.0003034712201378868d0
     &     *lfh**2)
      help(3,13) = 0.01621024645204334d0 - 0.0491926044205709d0*dlxm1 +
     &     0.0011288711288711289d0*dlxm1**2 - 0.0011288711288711289d0*z2
      help(3,13) = help(3,13) + (0.02459630221028545d0*lfh -
     &     0.0011288711288711289d0*dlxm1*lfh + 0.0002822177822177822d0
     &     *lfh**2)

C-}}}


      do k=0,nsoftmt(2,4)
         sum = 0.d0
         do j=2,nmtlim(2,4),2
            sum = sum + (mh/mt)**j * help(j/2,k)
         enddo
         helpmt(k) = sum
      enddo

C$$$      modified = 1
      sum = 0.d0
c..   this is  G(x) = sigma/xt^ncat2 :
      do k=0,nsoftmt(2,4)
         sum = 0.d0
         do i=0,k
            sum = sum + bininv(ncat2,i) * helpmt(k-i)
         enddo
         helpx(k) = sum
      enddo

      sqq2mtexp = 0.d0
      do k=0,nsoftmt(2,4)
         sqq2mtexp = sqq2mtexp + xm1**k * helpx(k)
      enddo

      sqq2mtexp = xt**ncat2 * sqq2mtexp

      return
      end

C-}}}
C-{{{ function squ2mtexp(xt)

      real*8 function squ2mtexp(xt)
C
C
      implicit none
      integer i,j,k
      real*8 xt,xm1,dlxm1,dlm1os,nl,sum,bininv
      real*8 help(10,0:20),helpmt(0:20),helpx(0:20)
      include '../commons/common-errors.f'
      include '../commons/common-expand.f'
      include '../commons/common-keys.f'
      include '../commons/common-consts.f'
      include '../commons/common-vars.f'

      if (lpseudo) stop 'squ2mtexp'
      if (nmtlim(2,5).gt.6) stop 'squ2mtexp'
      if (nsoftmt(2,5).gt.16) stop 'squ2mtexp'

      do i=0,20
         do j=1,10
            help(j,i) = 0.d0
         enddo
      enddo

      xm1 = 1.d0-xt
      dlxm1 = dlog(xm1)
 
      nl=nf
      dlm1os = - lth

C-{{{ 1/mt^2:

      help(1,0) = 0
      help(1,0) = help(1,0) + 0
      help(1,1) = 0.25925925925925924d0 - (28.d0*dlxm1)/135.d0 + (28.d0
     &     *dlxm1**2)/135.d0 - (28.d0*z2)/135.d0
      help(1,1) = help(1,1) + (14.d0*lfh)/135.d0 - (28.d0*dlxm1*lfh)
     &     /135.d0 + (7*lfh**2)/135.d0
      help(1,2) = 0.44814814814814813d0 - (4*dlxm1)/15.d0 + (14.d0*dlxm1
     &     **2)/135.d0 - (14.d0*z2)/135.d0
      help(1,2) = help(1,2) + (2*lfh)/15.d0 - (14.d0*dlxm1*lfh)/135.d0 +
     &     (7*lfh**2)/270.d0
      help(1,3) = 0.5954732510288065d0 - (40.d0*dlxm1)/81.d0 + (28.d0
     &     *dlxm1**2)/135.d0 - (28.d0*z2)/135.d0
      help(1,3) = help(1,3) + (20.d0*lfh)/81.d0 - (28.d0*dlxm1*lfh)
     &     /135.d0 + (7*lfh**2)/135.d0
      help(1,4) = 0.3950617283950617d0 - (97.d0*dlxm1)/270.d0 + (7*dlxm1
     &     **2)/45.d0 - (7*z2)/45.d0
      help(1,4) = help(1,4) + (97.d0*lfh)/540.d0 - (7*dlxm1*lfh)/45.d0 +
     &     (7*lfh**2)/180.d0
      help(1,5) = 0.31240301783264746d0 - (10616.d0*dlxm1)/30375.d0 +
     &     (266*dlxm1**2)/2025.d0 - (266.d0*z2)/2025.d0
      help(1,5) = help(1,5) + (5308.d0*lfh)/30375.d0 - (266.d0*dlxm1
     &     *lfh)/2025.d0+ (133.d0*lfh**2)/4050.d0
      help(1,6) = 0.23191810699588478d0 - (10681.d0*dlxm1)/30375.d0 +
     &     (77.d0*dlxm1**2)/675.d0 - (77.d0*z2)/675.d0
      help(1,6) = help(1,6) + (10681.d0*lfh)/60750.d0 - (77.d0*dlxm1
     &     *lfh)/675.d0 +(77.d0*lfh**2)/2700.d0
      help(1,7) = 0.15738797346098934d0 - (76063.d0*dlxm1)/212625.d0 +
     &     (68*dlxm1**2)/675.d0 - (68.d0*z2)/675.d0
      help(1,7) = help(1,7) + (76063.d0*lfh)/425250.d0 - (68.d0*dlxm1
     &     *lfh)/675.d0+ (17.d0*lfh**2)/675.d0
      help(1,8) = 0.0896535056409395d0 - (62159.d0*dlxm1)/170100.d0 +
     &     (73.d0*dlxm1**2)/810.d0 - (73.d0*z2)/810.d0
      help(1,8) = help(1,8) + (62159.d0*lfh)/340200.d0 - (73.d0*dlxm1
     &     *lfh)/810.d0+ (73.d0*lfh**2)/3240.d0
      help(1,9) = 0.028303193888437862d0 - (47666.d0*dlxm1)/127575.d0 +
     &     (11*dlxm1**2)/135.d0 - (11.d0*z2)/135.d0
      help(1,9) = help(1,9) + (23833.d0*lfh)/127575.d0 - (11.d0*dlxm1
     &     *lfh)/135.d0+ (11.d0*lfh**2)/540.d0
      help(1,10) = -0.027374528055392252d0 - (4639.d0*dlxm1)/12150.d0 +
     &     (301*dlxm1**2)/4050.d0 - (301.d0*z2)/4050.d0
      help(1,10) = help(1,10) + (4639.d0*lfh)/24300.d0 - (301.d0*dlxm1
     &     *lfh)/4050.d0 + (301.d0*lfh**2)/16200.d0
      help(1,11) = -0.0781001494398353d0 - (5156291.d0*dlxm1)/1.323135d7
     &     +(4564.d0*dlxm1**2)/66825.d0 - (4564.d0*z2)/66825.d0
      help(1,11) = help(1,11) + (5156291.d0*lfh)/2.64627d7 - (4564.d0
     &     *dlxm1*lfh)/66825.d0 + (1141.d0*lfh**2)/66825.d0
      help(1,12) = -0.1245207013526611d0 - (2335703.d0*dlxm1)/5.8806d6 +
     &     (469*dlxm1**2)/7425.d0 - (469.d0*z2)/7425.d0
      help(1,12) = help(1,12) + (2335703.d0*lfh)/1.17612d7 - (469.d0
     &     *dlxm1*lfh)/7425.d0 + (469.d0*lfh**2)/29700.d0
      help(1,13) = -0.1671938112278762d0 - (66954259.d0*dlxm1)
     &     /1.656369d8+(42.d0*dlxm1**2)/715.d0 - (42.d0*z2)/715.d0
      help(1,13) = help(1,13) + (66954259.d0*lfh)/3.312738d8 - (42.d0
     &     *dlxm1*lfh)/715.d0 + (21.d0*lfh**2)/1430.d0
      help(1,14) = -0.20659290182934095d0 - (779416753.d0*dlxm1)
     &     /1.8972954d9+ (289.d0*dlxm1**2)/5265.d0 - (289.d0*z2)/5265.d0
      help(1,14) = help(1,14) + (779416753.d0*lfh)/3.7945908d9 - (289.d0
     &     *dlxm1*lfh)/5265.d0 + (289.d0*lfh**2)/21060.d0
      help(1,15) = -0.2431182245262459d0 - (21974209.d0*dlxm1)
     &     /5.270265d7+(452.d0*dlxm1**2)/8775.d0 - (452.d0*z2)/8775.d0
      help(1,15) = help(1,15) + (21974209.d0*lfh)/1.054053d8 - (452.d0
     &     *dlxm1*lfh)/8775.d0 + (113.d0*lfh**2)/8775.d0
      help(1,16) = -0.27710843718422257d0 - (2284739.d0*dlxm1)/5.4054d6
     &     +(131.d0*dlxm1**2)/2700.d0 - (131.d0*z2)/2700.d0
      help(1,16) = help(1,16) + (2284739.d0*lfh)/1.08108d7 - (131.d0
     &     *dlxm1*lfh)/2700.d0 + (131.d0*lfh**2)/10800.d0

C-}}}
C-{{{ 1/mt^4:

      help(2,0) = 0
      help(2,0) = help(2,0) + 0
      help(2,1) = 0.034016754850088184d0 - (1543.d0*dlxm1)/56700.d0 +
     &     (1543*dlxm1**2)/56700.d0 - (1543.d0*z2)/56700.d0
      help(2,1) = help(2,1) + (1543.d0*lfh)/113400.d0 - (1543.d0*dlxm1
     &     *lfh)/56700.d0 + (1543.d0*lfh**2)/226800.d0
      help(2,2) = 0.06385582010582011d0 - (4541.d0*dlxm1)/113400.d0 +
     &     (1543*dlxm1**2)/113400.d0 - (1543.d0*z2)/113400.d0
      help(2,2) = help(2,2) + (4541.d0*lfh)/226800.d0 - (1543.d0*dlxm1
     &     *lfh)/113400.d0 + (1543.d0*lfh**2)/453600.d0
      help(2,3) = 0.07190157750342936d0 - (20849.d0*dlxm1)/340200.d0 +
     &     (1543*dlxm1**2)/56700.d0 - (1543.d0*z2)/56700.d0
      help(2,3) = help(2,3) + (20849.d0*lfh)/680400.d0 - (1543.d0*dlxm1
     &     *lfh)/56700.d0 + (1543.d0*lfh**2)/226800.d0
      help(2,4) = 0.03954248726239467d0 - (3241.d0*dlxm1)/97200.d0 +
     &     (1543*dlxm1**2)/75600.d0 - (1543.d0*z2)/75600.d0
      help(2,4) = help(2,4) + (3241.d0*lfh)/194400.d0 - (1543.d0*dlxm1
     &     *lfh)/75600.d0 + (1543.d0*lfh**2)/302400.d0
      help(2,5) = 0.024750447612515512d0 - (451417.d0*dlxm1)/2.5515d7 +
     &     (29317.d0*dlxm1**2)/1.701d6 - (29317.d0*z2)/1.701d6
      help(2,5) = help(2,5) + (451417.d0*lfh)/5.103d7 - (29317.d0*dlxm1
     &     *lfh)/1.701d6 + (29317.d0*lfh**2)/6.804d6
      help(2,6) = 0.015825448020772095d0 - (11777.d0*dlxm1)/7.29d6 +
     &     (16973*dlxm1**2)/1.134d6 - (16973.d0*z2)/1.134d6
      help(2,6) = help(2,6) + (11777.d0*lfh)/1.458d7 - (16973.d0*dlxm1
     &     *lfh)/1.134d6 + (16973.d0*lfh**2)/4.536d6
      help(2,7) = 0.013259407544238827d0 + (6310541.d0*dlxm1)/4.16745d8
     &     +(26231.d0*dlxm1**2)/1.9845d6 - (26231.d0*z2)/1.9845d6
      help(2,7) = help(2,7) + (-6310541.d0*lfh)/8.3349d8 - (26231.d0
     &     *dlxm1*lfh)/1.9845d6 + (26231.d0*lfh**2)/7.938d6
      help(2,8) = 0.01664856893630188d0 + (129925661.d0*dlxm1)
     &     /4.000752d9+(112639.d0*dlxm1**2)/9.5256d6 - (112639.d0*z2)
     &     /9.5256d6
      help(2,8) = help(2,8) + (-129925661.d0*lfh)/8.001504d9 - (112639
     &     *dlxm1*lfh)/9.5256d6 + (112639.d0*lfh**2)/3.81024d7
      help(2,9) = 0.02534740801474032d0 + (301746323.d0*dlxm1)
     &     /6.001128d9+(16973.d0*dlxm1**2)/1.5876d6 - (16973.d0*z2)
     &     /1.5876d6
      help(2,9) = help(2,9) + (-301746323.d0*lfh)/1.2002256d10 - (16973
     &     *dlxm1*lfh)/1.5876d6 + (16973.d0*lfh**2)/6.3504d6
      help(2,10) = 0.03871509982933394d0 + (117414811.d0*dlxm1)
     &     /1.714608d9+(66349.d0*dlxm1**2)/6.804d6 - (66349.d0*z2)
     &     /6.804d6
      help(2,10) = help(2,10) + (-117414811.d0*lfh)/3.429216d9 - (66349
     &     *dlxm1*lfh)/6.804d6 + (66349.d0*lfh**2)/2.7216d7
      help(2,11) = 0.056182671035965026d0 + (2707508423.d0*dlxm1)
     &     /3.11201352d10 + (251509.d0*dlxm1**2)/2.80665d7 - (251509.d0
     &     *z2)/2.80665d7
      help(2,11) = help(2,11) + (-2707508423.d0*lfh)/6.22402704d10 -
     &     (251509.d0*dlxm1*lfh)/2.80665d7 + (251509.d0*lfh**2)
     &     /1.12266d8
      help(2,12) = 0.0772632204627739d0 + (7316464783.d0*dlxm1)
     &     /6.9155856d10+ (103381.d0*dlxm1**2)/1.2474d7 - (103381.d0*z2)
     &     /1.2474d7
      help(2,12) = help(2,12) + (-7316464783.d0*lfh)/1.38311712d11 -
     &     (103381.d0*dlxm1*lfh)/1.2474d7 + (103381.d0*lfh**2)/4.9896d7
      help(2,13) = 0.10154496640022197d0 + (243137843383.d0*dlxm1)
     &     /1.947889944d12 + (1543.d0*dlxm1**2)/200200.d0 - (1543.d0*z2)
     &     /200200.d0
      help(2,13) = help(2,13) + (-243137843383.d0*lfh)/3.895779888d12 -
     &     (1543.d0*dlxm1*lfh)/200200.d0 + (1543.d0*lfh**2)/800800.d0
      help(2,14) = 0.12868020869557947d0 + (459122329403.d0*dlxm1)
     &     /3.187456272d12 + (445927.d0*dlxm1**2)/6.19164d7 - (445927.d0
     &     *z2)/6.19164d7
      help(2,14) = help(2,14) + (-459122329403.d0*lfh)/6.374912544d12 -
     &     (445927.d0*dlxm1*lfh)/6.19164d7 + (445927.d0*lfh**2)
     &     /2.476656d8
      help(2,15) = 0.1583744848340292d0 + (43409476207.d0*dlxm1)
     &     /2.65621356d11 + (174359.d0*dlxm1**2)/2.57985d7 - (174359.d0
     &     *z2)/2.57985d7
      help(2,15) = help(2,15) + (-43409476207.d0*lfh)/5.31242712d11 -
     &     (174359.d0*dlxm1*lfh)/2.57985d7 + (174359.d0*lfh**2)
     &     /1.03194d8
      help(2,16) = 0.19037716126759321d0 + (4272250597.d0*dlxm1)
     &     /2.3351328d10+ (202133.d0*dlxm1**2)/3.1752d7 - (202133.d0*z2)
     &     /3.1752d7
      help(2,16) = help(2,16) + (-4272250597.d0*lfh)/4.6702656d10 -
     &     (202133*dlxm1*lfh)/3.1752d7 + (202133.d0*lfh**2)/1.27008d8

C-}}}
C-{{{ 1/mt^6:

      help(3,0) = 0.d0
      help(3,0) = help(3,0) + (0.d0)
      help(3,1) = 0.0049823633156966494d0 - 0.0039858906525573196d0
     &     *dlxm1 + 0.0039858906525573196d0*dlxm1**2 -
     &     0.0039858906525573196d0*z2
      help(3,1) = help(3,1) + (0.0019929453262786598d0*lfh -
     &     0.0039858906525573196d0*dlxm1*lfh + 0.0009964726631393299d0
     &     *lfh**2)
      help(3,2) = 0.009660493827160494d0 - 0.006172839506172839d0*dlxm1
     &     + 0.0019929453262786598d0*dlxm1**2 - 0.0019929453262786598d0
     &     *z2
      help(3,2) = help(3,2) + (0.0030864197530864196d0*lfh -
     &     0.0019929453262786598d0*dlxm1*lfh + 0.0004982363315696649d0
     &     *lfh**2)
      help(3,3) = 0.010373799725651578d0 - 0.008894767783656672d0*dlxm1
     &     + 0.0039858906525573196d0*dlxm1**2 - 0.0039858906525573196d0
     &     *z2
      help(3,3) = help(3,3) + (0.004447383891828336d0*lfh -
     &     0.0039858906525573196d0*dlxm1*lfh + 0.0009964726631393299d0
     &     *lfh**2)
      help(3,4) = 0.00679465510484029d0 - 0.005349794238683128d0*dlxm1 +
     &     0.0029894179894179892d0*dlxm1**2 - 0.0029894179894179892d0*z2
      help(3,4) = help(3,4) + (0.002674897119341564d0*lfh -
     &     0.0029894179894179892d0*dlxm1*lfh + 0.0007473544973544973d0
     &     *lfh**2)
      help(3,5) = 0.006632050101247632d0 - 0.004605682931608858d0*dlxm1
     &     + 0.002524397413286302d0*dlxm1**2 - 0.002524397413286302d0*z2
      help(3,5) = help(3,5) + (0.002302841465804429d0*lfh -
     &     0.002524397413286302d0*dlxm1*lfh + 0.0006310993533215755d0
     &     *lfh**2)
      help(3,6) = 0.007785772584754066d0 - 0.005109700176366843d0*dlxm1
     &     + 0.0021922398589065257d0*dlxm1**2 - 0.0021922398589065257d0
     &     *z2
      help(3,6) = help(3,6) + (0.0025548500881834215d0*lfh -
     &     0.0021922398589065257d0*dlxm1*lfh + 0.0005480599647266314d0
     &     *lfh**2)
      help(3,7) = 0.009655552724659193d0 - 0.006950792451019208d0*dlxm1
     &     + 0.0019360040312421266d0*dlxm1**2 - 0.0019360040312421266d0
     &     *z2
      help(3,7) = help(3,7) + (0.003475396225509604d0*lfh -
     &     0.0019360040312421266d0*dlxm1*lfh + 0.00048400100781053164d0
     &     *lfh**2)
      help(3,8) = 0.011550691142684222d0 - 0.010211270781093155d0*dlxm1
     &     + 0.0017319643906945495d0*dlxm1**2 - 0.0017319643906945495d0
     &     *z2
      help(3,8) = help(3,8) + (0.005105635390546578d0*lfh -
     &     0.0017319643906945495d0*dlxm1*lfh + 0.0004329910976736374d0
     &     *lfh**2)
      help(3,9) = 0.012822666161380707d0 - 0.014944813375085485d0*dlxm1
     &     + 0.001565885613504661d0*dlxm1**2 - 0.001565885613504661d0*z2
      help(3,9) = help(3,9) + (0.007472406687542742d0*lfh -
     &     0.001565885613504661d0*dlxm1*lfh + 0.00039147140337616527d0
     &     *lfh**2)
      help(3,10) = 0.012899540074706697d0 - 0.021187561705066114d0*dlxm1
     &     + 0.0014282774838330393d0*dlxm1**2 - 0.0014282774838330393d0
     &     *z2
      help(3,10) = help(3,10) + (0.010593780852533057d0*lfh -
     &     0.0014282774838330393d0*dlxm1*lfh + 0.00035706937095825983d0
     &     *lfh**2)
      help(3,11) = 0.011285478772126755d0 - 0.028964913769397763d0*dlxm1
     &     + 0.0013125256088219051d0*dlxm1**2 - 0.0013125256088219051d0
     &     *z2
      help(3,11) = help(3,11) + (0.014482456884698881d0*lfh -
     &     0.0013125256088219051d0*dlxm1*lfh + 0.0003281314022054763d0
     &     *lfh**2)
      help(3,12) = 0.007551271964495665d0 - 0.03829533324842368d0*dlxm1
     &     + 0.0012138848805515472d0*dlxm1**2 - 0.0012138848805515472d0
     &     *z2
      help(3,12) = help(3,12) + (0.01914766662421184d0*lfh -
     &     0.0012138848805515472d0*dlxm1*lfh + 0.0003034712201378868d0
     &     *lfh**2)
      help(3,13) = 0.0013237519165837373d0 - 0.0491926044205709d0*dlxm1
     &     + 0.0011288711288711289d0*dlxm1**2 - 0.0011288711288711289d0
     &     *z2
      help(3,13) = help(3,13) + (0.02459630221028545d0*lfh -
     &     0.0011288711288711289d0*dlxm1*lfh + 0.0002822177822177822d0
     &     *lfh**2)
      help(3,14) = -0.007723659276517732d0 - 0.061667242877238126d0
     &     *dlxm1 + 0.001054873991381928d0*dlxm1**2 -
     &     0.001054873991381928d0*z2
      help(3,14) = help(3,14) + (0.030833621438619063d0*lfh -
     &     0.001054873991381928d0*dlxm1*lfh + 0.000263718497845482d0*lfh
     &     **2)
      help(3,15) = -0.019878830801814466d0 - 0.07572741753038863d0*dlxm1
     &     + 0.0009899025137120375d0*dlxm1**2 - 0.0009899025137120375d0
     &     *z2
      help(3,15) = help(3,15) + (0.037863708765194314d0*lfh -
     &     0.0009899025137120375d0*dlxm1*lfh + 0.0002474756284280094d0
     &     *lfh**2)
      help(3,16) = -0.03539733406659761d0 - 0.09137957415649214d0*dlxm1
     &     + 0.0009324137062232301d0*dlxm1**2 - 0.0009324137062232301d0
     &     *z2
      help(3,16) = help(3,16) + (0.04568978707824607d0*lfh -
     &     0.0009324137062232301d0*dlxm1*lfh + 0.00023310342655580752d0
     &     *lfh**2)

C-}}}

      do k=0,nsoftmt(2,5)
         sum = 0.d0
         do j=2,nmtlim(2,5),2
            sum = sum + (mh/mt)**j * help(j/2,k)
         enddo
         helpmt(k) = sum
      enddo

C$$$      modified = 1
      sum = 0.d0
c..   this is  G(x) = sigma/xt^ncat2 :
      do k=0,nsoftmt(2,5)
         sum = 0.d0
         do i=0,k
            sum = sum + bininv(ncat2,i) * helpmt(k-i)
         enddo
         helpx(k) = sum
      enddo

      squ2mtexp = 0.d0
      do k=0,nsoftmt(2,5)
         squ2mtexp = squ2mtexp + xm1**k * helpx(k)
      enddo

      squ2mtexp = xt**ncat2 * squ2mtexp

      return
      end

C-}}}

C-{{{ function sgg2mt(xt)

      real*8 function sgg2mt(xt)
C     
C     
      implicit real*8 (a-h,o-z)

      call printdieggh('sgg2mt: exact result not available.')

      sgg2mt = 0*xt

      return
      end

C-}}}
C-{{{ function sqg2mt(xt)

      real*8 function sqg2mt(xt)
C     
C     
      implicit real*8 (a-h,o-z)

      call printdieggh('sqg2mt: exact result not available.')

      sqg2mt = 0*xt

      return
      end

C-}}}
C-{{{ function sqqb2mt(xt)

      real*8 function sqqb2mt(xt)
C     
C     
      implicit real*8 (a-h,o-z)

      call printdieggh('sqqb2mt: exact result not available.')

      sqqb2mt = 0*xt

      return
      end

C-}}}
C-{{{ function sqq2mt(xt)

      real*8 function sqq2mt(xt)
C     
C     
      implicit real*8 (a-h,o-z)

      call printdieggh('sqq2mt: exact result not available.')

      sqq2mt = 0*xt

      return
      end

C-}}}
C-{{{ function squ2mt(xt)

      real*8 function squ2mt(xt)
C     
C     
      implicit real*8 (a-h,o-z)

      call printdieggh('squ2mt: exact result not available.')

      squ2mt = 0*xt

      return
      end

C-}}}
